// ============================================================
// Project				:	CityRPG
// Author				:	Iban, Jookia, And Pitfall
// Description			:	Datablocks
// ============================================================
// Table of Contents
// 1. Handling Script Start
// 2. Lots
// 2.2 Sale Lots
// 3. Data Bricks
// 4. Spawns
// 5. Resources
// 6. Other
// 7. Decals
// ============================================================

// ============================================================
// Section 1 : Handling Script Start
// ============================================================
$CityRPG::temp::brickError = forceRequiredAddOn("player_no_jet");

if($CityRPG::temp::brickError)
{
	if($CityRPG::temp::brickError == $error::addOn_disabled)
		playerNoJet.uiName = "";
	
	if($CityRPG::temp::brickError == $error::addOn_notFound)
		return;
}

$CityRPG::loadedDatablocks = true;

if(!$CityRPG::loadedDatablocks)
{
	return;
}

datablock triggerData(CityRPGLotTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};

datablock triggerData(CityRPGInputTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};


// ============================================================
// Section 2 : Lots
// ============================================================
datablock fxDTSBrickData(CityRPGSmallLotBrickData : brick16x16FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x16LotIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Lots";
	
	uiName = "Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 16 48";
	trigger = 0;
	
	initialPrice = 100;
	taxAmount = 10;
};

datablock fxDTSBrickData(CityRPGHalfSmallLotBrickData : brick16x32FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x32LotIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Lots";
	
	uiName = "Half-Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 32 48";
	trigger = 0;
	
	initialPrice = 350;
	taxAmount = 20;
};

datablock fxDTSBrickData(CityRPGMediumLotBrickData : brick32x32FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/32x32LotIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Lots";
	
	uiName = "Medium Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "32 32 64";
	trigger = 0;
	
	initialPrice = 500;
	taxAmount = 35;
};

datablock fxDTSBrickData(CityRPGLargeLotBrickData : brick64x64FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/64x64LotIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Lots";
	
	uiName = "Large Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "64 64 128";
	trigger = 0;
	
	initialPrice = 700;
	taxAmount = 45;
};

// Sale Lots
datablock fxDTSBrickData(CityRPGSmallZoneBrickData : brick16x16FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x16ZoneIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Zones";
	
	uiName = "Small Zone";

	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGHalfSmallZoneBrickData : brick16x32FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x32ZoneIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Zones";
	
	uiName = "Half-Small Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGHalfSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGMediumZoneBrickData : brick32x32FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/32x32ZoneIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Zones";
	
	uiName = "Medium Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGMediumLotBrickData;
};

datablock fxDTSBrickData(CityRPGLargeZoneBrickData : brick64x64FData)
{
	iconName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/64x64ZoneIcon";
	
	category = "PitfallMods";
	subCategory = "PitRPG Zones";
	
	uiName = "Large Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGLargeLotBrickData;
};

// ============================================================
// Section 3 : Data Bricks
// ============================================================
exec("./bricks/info/bank.cs");
exec("./bricks/info/police.cs");
exec("./bricks/info/bounty.cs");
exec("./bricks/info/labor.cs");
exec("./bricks/info/realestate.cs");

// ============================================================
// Section 4 : Spawns
// ============================================================
datablock fxDtsBrickData(CityRPGPersonalSpawnBrickData : brickSpawnPointData)
{
	category = "PitfallMods";
	subCategory = "PitRPG Spawns";
	
	uiName = "Personal Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = false;
	
	spawnData = "personalSpawn";
};

datablock fxDtsBrickData(CityRPGJailSpawnBrickData : brickSpawnPointData)
{
	category = "PitfallMods";
	subCategory = "PitRPG Spawns";
	
	uiName = "Jail Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = true;
	
	spawnData = "jailSpawn";
};

// ============================================================
// Section 5 : Resources
// ============================================================
exec("./bricks/resources/tree.cs");
exec("./bricks/resources/ore.cs");
exec("./bricks/resources/playerore.cs");

// ============================================================
// Section 6 : Other
// ============================================================
datablock fxDTSBrickData(CityRPGPermaSpawnData : brick2x2FData)
{
	category = "PitfallMods";
	subCategory = "PitRPG Admin";
	
	uiName = "Permaspawn Brick";

	CityRPGBrickAdmin = true;
	CityRPGPermaspawn = 1;
};

datablock fxDTSBrickData(CityRPGPoliceVehicleData : brickVehicleSpawnData)
{
	category = "PitfallMods";
	subCategory = "PitRPG Spawns";
	uiName = "Police Vehicle Spawn";
	CityRPGBrickAdmin = true;
};

DoorSO.addDoorTypeFromFile("Add-Ons/GameMode_PitroRP/bricks/doors/unbreakable.cs");
doorBrickUnbreakable.unbreakable = true;
doorBrickUnbreakable.CityRPGBrickAdmin = true;

// ============================================================
// Section 7 : Decals
// ============================================================
datablock decalData(PitropolisLogo)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/decals/Pitropolis";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_1)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x16LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_2)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x32LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_3)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/32x32LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Lot_Icon_4)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/64x64LotIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_1)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x16ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_2)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/16x32ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_3)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/32x32ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Zone_Icon_4)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/64x64ZoneIcon";
	preload = true;
};

datablock decalData(CityRPG_Ore_Icon)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/BrickIcons/4x Cube";
	preload = true;
};

datablock decalData(HungerIcon)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/decals/hungericon";
	preload = true;
};

datablock decalData(MoneyIcon)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/decals/moneyicon";
	preload = true;
};


datablock decalData(MoneyAddIcon)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/decals/moneyaddicon";
	preload = true;
};

datablock decalData(WantStar)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/decals/star";
	preload = true;
};

datablock decalData(Wantstar2)
{
	textureName = "Add-Ons/GameMode_PitroRP/shapes/decals/star2";
	preload = true;
};