// ============================================================
// Project				:	CityRPG
// Author				:	Iban & Pitfall 
// Description			:	Code used by all walks of life.
// ============================================================
// Table of Contents
// 1. Game CityRPG Functions
// 2. Brick CityRPG Functions
// 3. Client CityRPG Functions
// 4. Trigger Bullshit
// 5. Client->Server Commands
// 6. Local Misc. Functions
// 7. Misc. Shit Functions
// ============================================================

// ============================================================
// Section 1 : Game CityRPG Functions
// ============================================================

function CityRPG_AddDemerits(%blid, %demerits)
{
	%demerits = mFloor(%demerits);
	%currentDemerits = CityRPGData.getData(%blid).valueDemerits;
	%maxStars = CityRPG_GetMaxStars();
	
	CityRPGData.getData(%blid).valueDemerits += %demerits;
	
	if(CityRPGData.getData(%blid).valueDemerits >= $CityRPG::pref::demerits::demoteLevel && JobSO.job[CityRPGData.getData(%blid).valueJobID].law == true)
	{		
		CityRPGData.getData(%blid).valueJobID = 1;
		CityRPGData.getData(%blid).valueJailData = 1 SPC 0;
		
		%client = findClientByBL_ID(%blid);
		
		if(isObject(%client))
		{
			messageClient(%client, '', "\c6You have been demoted to" SPC CityRPG_DetectVowel(JobSO.job[1].name) SPC "\c3" @ JobSO.job[1].name @ "\c6.");
			
			%client.setInfo();
			
			if(isObject(%client.player))
			{
				serverCmdunUseTool(%client);
				
				%client.player.giveDefaultEquipment();
			}
		}
	}
	
	if(%client = findClientByBL_ID(%blid))
	{
		%client.setInfo();
		
		if(%client.getWantedLevel())
		{
			%ticks = %client.getWantedLevel();
			
			if(%ticks > %maxStars)
			{
				if(%maxStars == 3 || %maxStars == 6)
					messageAll('', '\c6Criminal \c3%1\c6 has obtained a level \c3%2\c6 wanted level. Police vehicles have upgraded.', %client.name, %ticks);
			}
		}
	}
}

function CityRPG_AssembleEvents()
{
	// Basic Input
	registerInputEvent("fxDTSBrick", "onEnterLot", "Self fxDTSBrick" TAB "Player player" TAB "Client gameConnection");
	registerInputEvent("fxDTSBrick", "onLeaveLot", "Self fxDTSBrick" TAB "Player player" TAB "Client gameConnection");
	registerInputEvent("fxDTSBrick", "onTransferSuccess", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection");
	registerInputEvent("fxDTSBrick", "onTransferDecline", "Self fxDTSBrick" TAB "Client GameConnection");
	registerInputEvent("fxDTSBrick", "onJobTestPass", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection");
	registerInputEvent("fxDTSBrick", "onJobTestFail", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection");
	
	// Basic Output
	registerOutputEvent("fxDTSBrick", "requestFunds", "string 80 200" TAB "int 1 9000 1");
	registerOutputEvent("GameConnection", "MessageBoxOK", "string 30 50" TAB "string 80 500");
	
	// Pain-in-the-Ass Output
	for(%a = 1; $CityRPG::portion[%a] !$= ""; %a++)
	{
		%sellFood_Portions = %sellFood_Portions SPC $CityRPG::portion[%a] SPC %a;
	}
	registerOutputEvent("fxDTSBrick", "sellFood", "list" @ %sellFood_Portions TAB "string 45 100" TAB "int 1 50 1");
	
	for(%b = 1; isObject(JobSO.job[%b]); %b++)
	{
		if(strlen(JobSO.job[%b].name) > 7)
			%jobName = getSubStr(JobSO.job[%b].name, 0, 6) @ ".";
		else
			%jobName = JobSO.job[%b].name;
		
		%doJobTest_List = %doJobTest_List SPC strreplace(%jobName, " ", "") SPC %b;
	}
	registerOutputEvent("fxDTSBrick", "doJobTest", "list NONE 0" @ %doJobTest_List TAB "list NONE 0" @ %doJobTest_List TAB "bool");
	
	for(%c = 1; isObject($CityRPG::prices::weapon::name[%c]); %c++)
	{
		%sellItem_List = %sellItem_List SPC strreplace($CityRPG::prices::weapon::name[%c].uiName, " ", "") SPC %c;
	}
	registerOutputEvent("fxDTSBrick", "sellItem", "list" @ %sellItem_List TAB "int 0 500 1");
	
	for(%d = 0; %d < ClientGroup.getCount(); %d++)
	{
		%subClient = ClientGroup.getObject(%d);
		serverCmdRequestEventTables(%subClient);
		messageClient(%subClient, '', "\c6Your Event Tables have been updated. If you do not know what that means, ignore this message.");
	}
}

function CityRPG_BootUp()
{
	if(!isObject(CityRPGData))
	{
		new scriptObject(CityRPGData)
		{
			class = Sassy;
			dataFile = "config/server/PitfallMods/PitroRP/Data.dat";
		};
		
		if(!isObject($DamageType::Starvation))
			AddDamageType("Starvation", '\c6 - %1 died of starvation.', '\c6 - %1 died of starvation.', 0.5, 1);
		
		if(!CityRPGData.loadedSaveFile)
		{
			CityRPGData.addValue("bank", $CityRPG::pref::players::startingCash);
			CityRPGData.addValue("bounty", "0");
			CityRPGData.addValue("demerits", "0");
			CityRPGData.addValue("depot", "");
			CityRPGData.addValue("education", "0");
			CityRPGData.addValue("gender", "ambig");
			CityRPGData.addValue("hunger", "6");
			CityRPGData.addValue("jailData", "0 0");
			CityRPGData.addValue("jobEXP", "1");
			CityRPGData.addValue("jobID", "1");
			CityRPGData.addValue("lotData", "0");
			CityRPGData.addValue("money", "0");
			CityRPGData.addValue("name", "noName");
			// accent hat pack secondPack chest arms gloves hip feet facedecal chestdecal
			CityRPGData.addValue("outfit", "none none none none whitet whitet skin bluejeans blackshoes");
			CityRPGData.addValue("reincarnated", "0");
			CityRPGData.addValue("resources", "0 0");
			CityRPGData.addValue("student", "0");
			CityRPGData.addValue("tools", "");
		}
		else
		{
			for(%a = 1; %a <= CityRPGData.dataCount; %a++)
			{
				if(CityRPGData.data[%a].valueJobID > JobSO.getJobCount() || CityRPGData.data[%a].valueJobID < 0)
				{
					CityRPGData.data[%a].valueJobID = 1;
				}
			}
		}
		
		
		CityRPG_AssembleEvents();
		
		CalendarSO.date = 0;
		CityRPGData.lastTickOn = $Sim::Time;
		CityRPGData.scheduleTick = schedule($CityRPG::tick::speed * 60000, false, "CityRPG_Tick");
	}
	else
	{
		for(%a = 1; %a <= CityRPGData.dataCount; %a++)
		{
			if(CityRPGData.data[%a].valueJobID > JobSO.getJobCount() || CityRPGData.data[%a].valueJobID < 0)
			{
				CityRPGData.data[%a].valueJobID = 1;
			}
		}
	}
	
	if(!isObject(CityRPGHelp))
	{
		new scriptObject(CityRPGHelp)
		{
			class = Hellen;
		};
	}
	
	if(!isObject(CityRPGMini))
	{
		CityRPG_BuildMinigame();
	}
}

function CityRPG_BuildMinigame()
{	
	if(isObject(CityRPGMini))
	{		
		for(%i = 0;%i < ClientGroup.getCount();%i++)
		{
			%subClient = ClientGroup.getObject(%i);
			CityRPGMini.removeMember(%subClient);
		}
		
		CityRPGMini.delete();
	}
	else
	{
		for(%i = 0;%i < ClientGroup.getCount();%i++)
		{
			%subClient = ClientGroup.getObject(%i);
			%subClient.minigame = NULL;
		}
	}
	
	new scriptObject(CityRPGMini)
	{
		class = miniGameSO;
		
		brickDamage = true;
		brickRespawnTime = 10000;
		colorIdx = -1;
		
		enableBuilding = true;
		enablePainting = true;
		enableWand = true;
		fallingDamage = true;
		inviteOnly = false;
		
		points_plantBrick = 0;
		points_breakBrick = 0;
		points_die = -1;
		points_killPlayer = 1;
		points_killSelf = -1;
		
		playerDatablock = playerNoJet;
		respawnTime = 0;
		selfDamage = true;
		
		playersUseOwnBricks = false;
		useAllPlayersBricks = true;
		useSpawnBricks = false;
		VehicleDamage = true;
		vehicleRespawnTime = 10000;
		weaponDamage = true;
		
		numMembers = 0;
		
		// Special:
		vehicleRunOverDamage = false;
	};
	
	for(%i = 0;%i < ClientGroup.getCount();%i++)
	{
		%subClient = ClientGroup.getObject(%i);
		CityRPGMini.addMember(%subClient);
	}
	
	CityRPGMini.playerDatablock.maxTools = 7;
}

function CityRPG_BuildSpawns()
{
	$CityRPG::temp::spawnPoints = "";
	for(%i = 0; %i < mainBrickGroup.getCount(); %i++)
	{
		%brickGroup = mainBrickGroup.getObject(%i);
		if(isObject(%brickGroup))
		{
			for(%j = 0; %j < %brickGroup.getCount(); %j++)
			{
				%brick = %brickGroup.getObject(%j);
				if(%brick.getDatablock().CityRPGBrickType == 3)
				{
					$CityRPG::temp::spawnPoints = (!$CityRPG::temp::spawnPoints ? %brick : $CityRPG::temp::spawnPoints SPC %brick);
				}
			}
		}
	}
}

function CityRPG_DetectVowel(%word)
{
	%letter = strLwr(getSubStr(%word, 0, 1));
	
	if(%letter $= "a" || %letter $= "e" || %letter $= "i" || %letter $= "o" || %letter $= "u")
		return "an";
	else
		return "a";	
}

function CityRPG_FindSpawn(%search, %id)
{
	%search = strlwr(%search);
	%fullSearch = %search @ (%id ? " " @ %id : "");
	
	for(%a = 0; %a < getWordCount($CityRPG::temp::spawnPoints); %a++)
	{
		%brick = getWord($CityRPG::temp::spawnPoints, %a);
		
		if(isObject(%brick))
		{
			%spawnData = strLwr(%brick.getDatablock().spawnData);
			
			if(%search $= %spawnData && %spawnData $= "personalspawn")
			{
				%ownerID = getBrickGroupFromObject(%brick).bl_id;
				
				if(%fullSearch $= (%spawnData SPC %ownerID))
					%possibleSpawns = (%possibleSpawns $= "") ? %brick : %possibleSpawns SPC %brick;
			}
			else if(%fullSearch $= %spawnData)
				%possibleSpawns = (%possibleSpawns $= "") ? %brick : %possibleSpawns SPC %brick;
		}
		else
			$CityRPG::temp::spawnPoints = strreplace($CityRPG::temp::spawnPoints, %brick, "");
	}
	
	if(%possibleSpawns !$= "")
	{
		%spawnBrick = getWord(%possibleSpawns, getRandom(0, getWordCount(%possibleSpawns) - 1));
		%cords = vectorSub(%spawnBrick.getWorldBoxCenter(), "0 0" SPC (%spawnBrick.getDatablock().brickSizeZ - 3) * 0.1) SPC getWords(%spawnBrick.getTransform(), 3, 6);
		return %cords;
	}
	else
		return false;	
}

function CityRPG_GetMaxStars()
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		%theirStars = %subClient.getWantedLevel();
		if(%theirStars > %maxStars)
			%maxStars = %theirStars;
	}
	
	return (%maxStars $= "" ? 0 : %maxStars);
}

function CityRPG_GetMostWanted()
{
	%maxStars = CityRPG_GetMaxStars();
	for(%a = 0; %a < Clientgroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		if(%subClient.getWantedLevel() == %maxStars)
			%mostWanted = %subClient;
	}
	
	return (isObject(%mostWanted) ? %mostWanted : 0);
}

function CityRPG_illegalAttackTest(%atkr, %vctm)
{
	if(isObject(%atkr) && isObject(%vctm) && %atkr.getClassName() $= "GameConnection" && %vctm.getClassName() $= "GameConnection")
	{
		if(%atkr != %vctm)
		{				
			if(CityRPGData.getData(%vctm.bl_id).valueBounty && %atkr.getJobSO().bountyClaim)
				return false;
			else if(!%vctm.getWantedLevel())
				return true;
		}
	}
	
	return false;
}

function CityRPG_Tick()
{
	echo("Time Passes");
	
	CalendarSO.date++;
	CityRPGData.lastTickOn = $Sim::Time;
	
	if(CityRPGData.scheduleTick)
		cancel(CityRPGData.scheduleTick);
	
	CalendarSO.getDate(%client);
	CityRPG_BuildSpawns();
	
	//if(isFunction("dediSave"))
	//	dediSave("CityRPG_TickSave", "File was saved at the start of a tick.", true, true);
	
	CityRPG_DoTickLoop(0);
	
	CityRPGData.scheduleTick = schedule((60000 * $CityRPG::tick::speed), false, "CityRPG_Tick");
	
	CityRPGData.saveData();
	CalendarSO.saveData();
	CitySO.saveData();
}

function CityRPG_DoTickLoop(%loop)
{
	%time = (($CityRPG::tick::speed * 60000) / CityRPGData.dataCount);
	
	if(isObject(%client = findClientByBL_ID(CityRPGData.data[%loop].ID)))
		%client.tick();
	
	if(CalendarSO.date && CalendarSO.date % $CityRPG::tick::interestTick == 0)
	{
		CityRPGData.data[%loop].valueBank = mFloor(CityRPGData.data[%loop].valueBank * $CityRPG::tick::interest);
		
		if(isObject(%client))
			messageClient(%client, '', "\c6 - The bank is giving interest.");
	}
	
	if(getWord(CityRPGData.data[%loop].valueJailData, 1))
	{
		CityRPGData.data[%loop].valueJailData = 1 SPC (getWord(CityRPGData.data[%loop].valueJailData, 1) - 1);
		
		if(isObject(%client))
		{
			if(!getWord(CityRPGData.getData(CityRPGData.data[%loop].ID).valueJailData, 1))
			{
				messageClient(%client, '', "\c6 - You got out of prison.");
				%client.buyResources();
				%client.spawnPlayer();
			}
		}
	}
	
	if(%loop < CityRPGData.dataCount)
		schedule(%time, false, "CityRPG_DoTickLoop", (%loop + 1));
}

function messageAllOfJob(%job, %type, %message)
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		if(%subClient.getJobSO().id == %job)
		{
			messageClient(%subClient, %type, %message);
			%sent++;
		}
	}
	
	return (%sent !$= "" ? %sent : 0);
}

// ============================================================
// Section 2 : Brick CityRPG Functions
// ============================================================
function fxDTSBrick::handleCityRPGBrickCreation(%brick, %data)
{
	if(!isObject(%brick.trigger))
	{
		%datablock = %brick.getDatablock();
		
		%trigX = getWord(%datablock.triggerSize, 0);
		%trigY = getWord(%datablock.triggerSize, 1);
		%trigZ = getWord(%datablock.triggerSize, 2);
		
		if(mFloor(getWord(%brick.rotation, 3)) == 90)
			%scale = (%trigY / 2) SPC (%trigX / 2) SPC (%trigZ / 2);
		else
			%scale = (%trigX / 2) SPC (%trigY / 2) SPC (%trigZ / 2);
			
		
		%brick.trigger = new trigger()
		{
			datablock = %datablock.triggerDatablock;
			position = getWords(%brick.getWorldBoxCenter(), 0, 1) SPC getWord(%brick.getWorldBoxCenter(), 2) + ((getWord(%datablock.triggerSize, 2) / 4) + (%datablock.brickSizeZ * 0.1));
			rotation = "1 0 0 0";
			scale = %scale;
			polyhedron = "-0.5 -0.5 -0.5 1 0 0 0 1 0 0 0 1";
			parent = %brick;
		};
		
		%boxSize = getWord(%scale, 0) / 2.5 SPC getWord(%scale, 1) / 2.5 SPC getWord(%scale, 2) / 2.5;
		
		initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
		
		while(isObject(%player = containerSearchNext()))
			%brick.trigger.getDatablock().onEnterTrigger(%brick.trigger, %player);
		
		if(%brick.getDatablock().CityRPGBrickType == 1)
		{
			getBrickGroupFromObject(%brick).taxes += %brick.getDatablock().taxAmount;
			getBrickGroupFromObject(%brick).lotsOwned++;
			
			if(isObject(getBrickGroupFromObject(%brick).client))
				getBrickGroupFromObject(%brick).client.SetInfo();
		}
	}
}

function fxDTSBrick::handleCityRPGBrickDelete(%brick, %data)
{
	if(isObject(%brick.trigger))
	{
		for(%a = 0; %a < clientGroup.getCount(); %a++)
		{
			%subClient = ClientGroup.getObject(%a);
			if(isObject(%subClient.player) && %subClient.CityRPGTrigger == %brick.trigger)
				%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, clientGroup.getObject(%a).player, true);
		}
		
		%boxSize = getWord(%brick.trigger.scale, 0) / 2.5 SPC getWord(%brick.trigger.scale, 1) / 2.5 SPC getWord(%brick.trigger.scale, 2) / 2.5;
		
		initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
		
		while(isObject(%player = containerSearchNext()))
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, %player);
		
		%brick.trigger.delete();
		
		if(%brick.getDatablock().CityRPGBrickType == 1)
		{
			getBrickGroupFromObject(%brick).taxes -= %brick.getDatablock().taxAmount;
			getBrickGroupFromObject(%brick).lotsOwned--;
			
			if(isObject(getBrickGroupFromObject(%brick).client))
				getBrickGroupFromObject(%brick).client.SetInfo();
			
			if(%brick.getName() !$= "")
			{
				%data = CityRPGData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData;
				
				%newData = getWord(%data, 0) - 1;
				
				for(%a = 1; %a < getWordCount(%data); %a++)
				{
					if(%cancelNext)
					{
						%cancelNext = false;
						continue;
					}
					
					%newData = %newData SPC getWord(%data, %a);
					
					if(%a % 2 == 0)
						continue;
					
					%newBrick = "_" @ getWord(%data, %a);
					if(isObject(%newBrick) && %newBrick $= %brick.getName())
					{
						%found = true;
						
						%newData = getWords(%newData, 0, getWordCount(%newData) - 2);
						
						%cancelNext = true;
					}
				}
				
				if(%found)
				{
					CityRPGData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData = %newData;
				}
			}
		}
	}	
}

function fxDTSBrick::transferLot(%brick, %targetBG)
{
	%ownerBG = getBrickGroupFromObject(%brick);
	
	if(%brick.tran || !isObject(%brick))
		return;
	
	if(isObject(%ownerBG))
		%ownerBG.remove(%brick);
	
	%targetBG.add(%brick);
	%brick.tran = 1;
	%brick.transferLot(%targetBG);
	
	for(%i = 0; %i < %brick.getNumUpBricks(); %i++)
	{
		%target = %brick.getUpBrick(%i);
		if(isObject(%target))
			%target.transferLot(%targetBG);
	}
}

// Labor Functions
function fxDTSBrick::onChop(%this, %client)
{
	if(%this.resources > 0 && !%this.isFakeDead())
	{
		if(getRandom(1, 100) > (95 - mFloor((CityRPGData.getData(%client.bl_id).valueEducation / 6) * 4)))
		{
			%this.resources--;
			
			if(%this.resources)
				commandToClient(%client, 'centerPrint' , "\c6Lumber obtained.", 1);
			else
			{
				commandToClient(%client, 'centerPrint' , "\c6Lumber obtained, however you killed the tree in the process.", 3);
				%this.fakeKillBrick(getRandom(-10, 10) SPC getRandom(-10, 10) SPC getRandom(0, 10), getRandom(120, 180));
				%this.resources = %this.getDatablock().resources;
			}
			
			CityRPGData.getData(%client.bl_id).valueResources = (getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + 1) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
			%client.SetInfo();
			
			if(%client.getJobSO().laborer)
				CityRPGData.getData(%client.bl_id).valueJobEXP++;
		}
	}
}

function fxDTSBrick::onDig(%this, %client)
{
	
}

function fxDTSBrick::onMine(%this, %client)
{
	if(isObject(%this) && isObject(%client))
	{
		if(%this.hasOre && %this.resources == 0)
			%this.resources = %this.getDatablock().resources;
		
		if(%this.resources > 0)
		{
			%this.hasOre = true;
			if(getRandom(1, 100) > (90 - mFloor((CityRPGData.getData(%client.bl_id).valueEducation / 6) * 4)))
			{
				%this.resources--;
				
				if(getRandom(1, 100) > 100 - CityRPGData.getData(%client.bl_id).valueEducation)
					%gemstone = true;
				
				if(%gemstone)
				{
					%value = getRandom(5, 50);
					commandToClient(%client, 'centerPrint', "\c1Gemstone obtained.", 1);
					messageClient(%client, '', "\c6You extracted a gem from the rock worth \c3$" @ %value @ "\c6.");
					CityRPGData.getData(%client.bl_id).valueMoney += %value;
				}
				else
				{
					if(!%this.resources)
					{
						commandToClient(%client, 'centerPrint', "\c6You have emptied this rock of its resources!", 3);
						%this.adjustColorOnOreContent();
					}
					else
						commandToClient(%client, 'centerPrint', "\c6Minerals obtained.", 1);
					
					CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC (getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) + 1);
				}
				
				if(%client.getJobSO().laborer)
					CityRPGData.getData(%client.bl_id).valueJobEXP++;
				
				%client.SetInfo();
			}
		}
	}
}

 function fxDTSBrick::onwrench(%this, %client)
{
	if(isObject(%this) && isObject(%client))
	{
		if(%this.hasOre && %this.resources == 0)
			%this.resources = %this.getDatablock().resources;
		
		if(%this.resources > 0)
		{
			%this.hasOre = true;
			if(getRandom(1, 70) > (90 - mFloor((CityRPGData.getData(%client.bl_id).valueEducation / 6) * 4)))
			{
				%this.resources--;
				
				if(getRandom(1, 100) > 100 - CityRPGData.getData(%client.bl_id).valueEducation)
					%gemstone = true;
				
				if(%gemstone)
				{
					%value = getRandom(5, 50);
					commandToClient(%client, 'centerPrint', "\c1You found a defect .", 1);
					messageClient(%client, '', "\c6You found a defect and were awarded \c3$" @ %value @ "\c6.");
					CityRPGData.getData(%client.bl_id).valueMoney += %value;
				}
				else
				{
					if(!%this.resources)
					{
						commandToClient(%client, 'centerPrint', "\c6The item has moved down thr line.", 3);
						%this.adjustColorOnOreContent();
					}
					else
						commandToClient(%client, 'centerPrint', "\c6You finished what ever you are makeing.", 1);
					
					CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC (getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) + 1);
				}
				
				if(%client.getJobSO().laborer)
					CityRPGData.getData(%client.bl_id).valueJobEXP++;
				
				%client.SetInfo();
			}
		}
	}
}

// Input Events
function fxDTSBrick::onEnterLot(%brick, %obj)
{
	$inputTarget_self = %brick;
	
	$inputTarget_client = %obj.client;
	$inputTarget_player = %obj.client.player;
	
	$inputTarget_miniGame = (isObject(getMiniGameFromObject(%obj.client))) ? getMiniGameFromObject(%obj.client) : 0;
	
	%brick.processInputEvent("OnEnterLot", %obj.client);
}

function fxDTSBrick::onLeaveLot(%brick, %obj)
{
	$inputTarget_self = %brick;
	
	$inputTarget_client = %obj.client;
	$inputTarget_player = %obj.client.player;
	
	$inputTarget_miniGame = (isObject(getMiniGameFromObject(%obj.client))) ? getMiniGameFromObject(%obj.client) : 0;
	
	%brick.processInputEvent("OnLeaveLot", %obj.client);
}

function fxDTSBrick::onTransferSuccess(%brick, %client)
{
	$inputTarget_self	= %brick;
	$inputTarget_player	= %client.player;
	$inputTarget_client	= %client;
	
	%brick.processInputEvent("onTransferSuccess", %client);
}

function fxDTSBrick::onTransferDecline(%brick, %client)
{
	$inputTarget_self	= %brick;
	$inputTarget_client	= %client;
	
	// Repeated Service Offer Hack
	for(%i = 0; %i < %brick.numEvents; %i++)
	{
		if(%brick.eventInput[%i] $= "onTransferDecline" && (%brick.eventOutput[%i] $= "requestFunds" || %brick.eventOutput[%i] $= "sellItem" || %brick.eventOutput[%i] $= "sellFood"))
			%brick.eventEnabled[%i] = false;
	}
	
	%brick.processInputEvent("onTransferDecline", %client);
}

function fxDTSBrick::onJobTestPass(%brick, %client)
{
	$inputTarget_self	= %brick;
	$inputTarget_player	= %client.player;
	$inputTarget_client	= %client;
	
	%brick.processInputEvent("onJobTestPass", %client);
}

function fxDTSBrick::onJobTestFail(%brick, %client)
{
	$inputTarget_self	= %brick;
	$inputTarget_player	= %client.player;
	$inputTarget_client	= %client;
	
	%brick.processInputEvent("onJobTestFail", %client);
}

// Output Events
function fxDTSBrick::doJobTest(%brick, %job, %job2, %convicts, %client)
{
	%convictStatus = getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1);
	
	if(!%job && !%job2 && (%convicts ? (!%convictStatus ? true : false) : true))
		%brick.onJobTestPass(%client);
	else if((CityRPGData.getData(%client.bl_id).valueJobID == %job || CityRPGData.getData(%client.bl_id).valueJobID == %job2) &&
		(%convicts ? (!%convictStatus ? true : false) : true))
		%brick.onJobTestPass(%client);
	else
		%brick.onJobTestFail(%client);
}

function fxDTSBrick::requestFunds(%brick, %serviceName, %fund, %client)
{	
	if(isObject(%client.player) && !%client.player.serviceOrigin  && isObject(%brick))
	{		
		%client.player.serviceOrigin = %brick;
		%client.player.serviceFee = %fund;
		%client.player.serviceType = "service";
		
		messageClient(%client,'',"\c6Service \"\c3" @ %serviceName @ "\c6\" requests \c3$" @ %fund SPC "\c6.");
		messageClient(%client,'',"\c6Accept with \c3/yes\c6, decline with \c3/no\c6.");
	}
	else if(%client.player.serviceOrigin && %client.player.serviceOrigin != %brick)
	{
		messageClient(%client, '', "\c6You already have a charge request from another service! Type \c3/no\c6 to reject it.");
	}
}

function fxDTSBrick::sellFood(%brick, %portion, %food, %markup, %client)
{
	if(isObject(%client.player) && !%client.player.serviceOrigin  && isObject(%brick))
	{
		%client.player.serviceType = "food";
		%client.player.serviceItem = %food;
		%client.player.serviceSize = %portion;
		%client.player.serviceFee = (5 * %portion - mFloor(%portion * 0.75)) +  %markup;
		%client.player.serviceMarkup = %markup;
		%client.player.serviceOrigin = %brick;
		
		messageClient(%client,'','\c6A service is offering to feed you %1 \c3%2\c6 portion of \c3%3\c6 for \c3$%4\c6.', CityRPG_DetectVowel($CityRPG::portion[%portion]), strreplace($CityRPG::portion[%portion], "_", " "), %food, %client.player.serviceFee);
		messageClient(%client,'',"\c6Accept with \c3/yes\c6, decline with \c3/no\c6.");
	}
	else if(%client.player.serviceOrigin && %client.player.serviceOrigin != %brick)
		messageClient(%client, '', "\c6You already have a charge request from another service! Type \c3/no\c6 to reject it.");
}

function fxDTSBrick::sellItem(%brick, %item, %markup, %client)
{
	if(isObject(%client.player) && !%client.player.serviceOrigin  && isObject(%brick))
	{
		%name = $CityRPG::prices::weapon::name[%item].uiName;
		
		if(CitySO.minerals >= $CityRPG::prices::weapon::mineral[%item])
		{
			%client.player.serviceType = "item";
			%client.player.serviceItem = %item;
			%client.player.serviceFee = $CityRPG::prices::weapon::price[%item] + %markup;
			%client.player.serviceMarkup = %markup;
			%client.player.serviceOrigin = %brick;
			
			messageClient(%client,'',"\c6A service is offering to sell you one \c3" @ %name SPC "\c6for \c3$" @ %client.player.serviceFee SPC "\c6.");
			messageClient(%client,'',"\c6Accept with \c3/yes\c6, decline with \c3/no\c6.");
		}
		else
			messageClient(%client, '', '\c6A service is trying to offer you %1 \c3%2\c6, but the city needs \c3%3\c6 more minerals to produce it!', CityRPG_DetectVowel(%name), %name, ($CityRPG::prices::weapon::mineral[%item] - CitySO.minerals));
	}
	else if(%client.player.serviceOrigin && %client.player.serviceOrigin != %brick)
		messageClient(%client, '', "\c6You already have a charge request from another service! Type \c3/no\c6 to reject it.");
}

function fxDTSBrick::sellClothes(%brick, %item, %markup, %client)
{
	echo("Error");
	if(isObject(%client.player) && !%client.player.serviceOrigin  && isObject(%brick))
	{
		%client.player.serviceType = "clothes";
		%client.player.serviceItem = %item;
		%client.player.serviceFee = %markup;
		%client.player.serviceMarkup = %markup;
		%client.player.serviceOrigin = %brick;
		
		messageClient(%client,'', '\c6A clothing service is offering to dress you in %1 \c3%2 \c6for \c3$%3\c6.', CityRPG_DetectVowel(ClothesSO.sellName[%item]), ClothesSO.sellName[%item], %client.player.serviceFee);
		messageClient(%client,'', "\c6Accept with \c3/yes\c6, decline with \c3/no\c6.");
	}
	else if(%client.player.serviceOrigin && %client.player.serviceOrigin != %brick)
		messageClient(%client, '', "\c6You already have a charge request from another service! Type \c3/no\c6 to reject it.");
}

// ============================================================
// Section 3 : Client CityRPG Functions
// ============================================================
function gameConnection::arrest(%client, %cop)
{
	if(%ticks = %client.getWantedLevel())
	{
		%copSO = CityRPGData.getData(%cop.bl_id);
		%robSO = CityRPGData.getData(%client.bl_id);
		
		if(!getWord(%robSO.valueJailData, 1))
		{
			if(%client.player.currTool)
				serverCmddropTool(%client, %client.player.currTool);
		}
		
		%ticks += getWord(%robSO.valueJailData, 1);
		%reward = mFloor($CityRPG::prices::jailingBonus * %ticks);
		%copSO.valueMoney += %reward;
		
		commandToClient(%client, 'messageBoxOK', "You've been Jailed by" SPC %cop.name @ "!", 'You have been jailed for %1 tick%2.\nToo bad, so sad.\n\nYou may either wait out your jail time in game and possibly earn money by laboring, or you may leave the server and return when your time is up.\nThe choice is yours.', %ticks, %ticks == 1 ? "" : "s");
		commandToClient(%cop, 'centerPrint', "\c6You have jailed \c3" @ %client.name SPC "\c6for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ". You were rewarded \c3$" @ %reward @ "\c6.", 5);
		
		%robSO.valueJailData = 1 SPC %ticks;
		%robSO.valueDemerits = 0;
		
		%cop.SetInfo();
		
		if(%client.getJobSO().law)
		{
			messageClient(%client, '', "\c6You have been demoted to" SPC CityRPG_DetectVowel(JobSO.job[1].name) SPC "\c3" @ JobSO.job[1].name SPC "\c6due to your jailing.");
			%robSO.valueJobID = 1;
		}
		
		if(%cop.getJobSO().law)
			%copSO.valueJobEXP++;
		
		if(%robSO.valueBounty > 0)
		{
			messageClient(%cop, '', "\c6Wanted man was apprehended successfully. His bounty money has been wired to your bank account.");
			%copSO.valueBank += %robSO.valueBounty;
			%robSO.valueBounty = 0;
		}
		
		if(%robSO.valueHunger < 3)
			%robSO.valueHunger = 3;
		
		if(isObject(%client.player.tempBrick))
			%client.player.tempBrick.delete();
		
		%client.spawnPlayer();
		
		if(%ticks == CityRPG_GetMaxStars())
		{
			%maxWanted = CityRPG_GetMostWanted();
			
			if(%maxWanted)
				messageAll('', '\c6The \c3%1-star\c6 criminal \c3%2\c6 was arrested by \c3%5\c6, but \c3%3-star\c6 criminal \c3%4\c6 is still at large!', %ticks, %client.name, %maxWanted.getWantedLevel(), %maxWanted.name, %cop.name);
			else
				messageAll('', '\c6With the apprehension of \c3%1-star\c6 criminal \c3%2\c6 by \c3%3\c6, the City returns to a peaceful state.', %ticks, %client.name, %cop.name);
		}
		else
			messageAll('', '\c3%1\c6 was jailed by \c3%2\c6 for \c3%3\c6 ticks.', %client.name, %cop.name, %ticks);
	}
}

function gameConnection::buyResources(%client)
{
	%totalResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) + getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
	
	if(mFloor(%totalResources * $CityRPG::prices::resourcePrice) > 0)
	{	
		%product = mFloor(%totalResources * $CityRPG::prices::resourcePrice);
		
		if(%client.getJobSO().laborer && !getWord(CityRPGData.getData(%client.bl_id).valueJobID, 1))
		{
			%product *= getRandom(1.5 + (CityRPGData.getData(%client.bl_id).valueEducation / 12), 2.0 + (CityRPGData.getData(%client.bl_id).valueEducation / 12));
			%product = mFloor(%product);
		}
		
		if(!getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1))
		{
			CityRPGData.getData(%client.bl_id).valueMoney += %product;
			messageClient(%client, '', "\c6The state has bought all of your resources for \c3$" @ %product @ "\c6.");
		}
		else
		{
			CityRPGData.getData(%client.bl_id).valueBank += %product;
			messageClient(%client, '', '\c6The state has set aside \c3$%1\c6 for when you get out of Prison.', %product);
		}
		
		CitySO.lumber += getWord(CityRPGData.getData(%client.bl_id).valueResources, 0);
		CitySO.minerals += getWord(CityRPGData.getData(%client.bl_id).valueResources, 1);
		
		CityRPGData.getData(%client.bl_id).valueResources = "0 0";
		
		%client.SetInfo();	
	}
}

function gameConnection::doIPKTest(%client) 
{
	if(isObject(%client))
	{
		if(isObject(%client.player))
		{
			if(%client.player.lasPos $= %client.player.getPosition() && %client.player.lasPos)
			{
				if(($sim::Time - %client.lastSpokeOn) > 60000)
					%client.minutesIdle += 1;
			}
			else
			{
				%client.player.lasPos = %client.player.getPosition();
				%client.minutesIdle = 0;
			}
		}
		else
		{
			if(%client.hasBeenDead)
				if(($sim::Time - %client.lastSpokeOn) > 60000)
					%client.minutesIdle += 1;
			else
			{
				if(%client.hasSpawnedOnce)
				{
					%client.hasBeenDead = true;
					%client.minutesIdle = 0;
				}
			}
		}
	}
	
	if(%client.minutesIdle >= 6)
	{
		%name = %client.name;
		%client.delete("Sorry, you have been kicked for being 6 minutes idle.");
		messageAll('', '\c1%1 has been kicked after being idle for %2 minutes.', %name, 6);
	}
	else
		%client.schedule(60000, "doIPKTest");
}

function gameConnection::setInfo(%client)
{
	CityRPGData.getData(%client.bl_id).valueMoney = mFloor(CityRPGData.getData(%client.bl_id).valueMoney);
	CityRPGData.getData(%client.bl_id).valueName = %client.name;
	
	if(isObject(%client.player))
	{		
		%client.player.setShapeName("foobar");
		%client.player.setShapeNameColor("foobar");
		%client.player.setShapeNameDistance(24);
		
		%client.setGameBottomPrint();
	}
}

function gameConnection::setGameBottomPrint(%client)
{
	// Font
	%mainFont = "<font:impact:18>";
	%client.CityRPGPrint = %mainFont;
	
	// Job
	if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1))
		%jobName = "Convict";
	else if(CityRPGData.getData(%client.bl_id).valueStudent)
		%jobName = "Student" SPC %client.getJobSO().name;
	else
		%jobName = %client.getJobSO().name;
	
	%client.CityRPGPrint = %client.CityRPGPrint @ "\c6Job: \c3" @ %jobName;
	
	// Money
	%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Money:" SPC %client.getCashString();
	
	// Salary
	if(%client.getSalary() > 0)
		%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Income: <color:336600>$" @ %client.getSalary();
	
	// Taxes
	if(%client.brickGroup.taxes > 0)
		%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Taxes: <color:ff0000>$" @ %client.brickGroup.taxes;
	
	// Resources
	if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) || %client.getJobSO().laborer || getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) > 0 || getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) > 0)
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) > 0)
			%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Lumber: \c3" @ (strlen(getWord(CityRPGData.getData(%client.bl_id).valueResources, 0)) > 0 ? getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) : 0);
		
		if(getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) > 0)
			%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Ore: \c3" @ (strlen(getWord(CityRPGData.getData(%client.bl_id).valueResources, 1)) > 0 ? getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) : 0);
	}
	
	// Hunger
	%hexColor = $CityRPG::food::color[CityRPGData.getData(%client.bl_id).valueHunger];
	%hungerName = $CityRPG::food::state[CityRPGData.getData(%client.bl_id).valueHunger];
	%client.CityRPGPrint = %client.CityRPGPrint SPC "\c6Hunger: <color:" @ %hexColor @ ">" @ %hungerName;
	
	// Wanted Level
	if(CityRPGData.getData(%client.bl_id).valueDemerits >= $CityRPG::pref::demerits::wantedLevel)
	{
		%client.CityRPGPrint = %client.CityRPGPrint SPC "<color:ffffff>Wanted:";
		%stars = %client.getWantedLevel();
		%client.CityRPGPrint = %client.CityRPGPrint SPC "<color:ffff00>";
		
		for(%a = 0; %a < %stars; %a++)
			%client.CityRPGPrint = %client.CityRPGPrint @ "*";
		
		%client.CityRPGPrint = %client.CityRPGPrint @ "<color:888888>";
		for(%a = %a; %a < 6; %a++)
			%client.CityRPGPrint = %client.CityRPGPrint @ "*";
		
		%client.CityRPGPrint = %client.CityRPGPrint @ %mainFont;
	}
	
	// Lot Info
	if(isObject(%client.CityRPGLotBrick)) %client.CityRPGPrint = %client.CityRPGPrint SPC "   <color:fff000>" @ getBrickGroupFromObject(%client.CityRPGLotBrick).name;	
	
	// Printing
	commandToClient(%client, 'bottomPrint', %client.CityRPGPrint, 0, true);
	
	return %client.CityRPGPrint;
}

function gameConnection::tick(%client)
{
	// I know I have never short-declared the client's scriptobject previously.
	// However, the tick occures far too often for it to be neglected.
	// Each "getData" runs through a small script. Because it appears 22 times in this function
	// I feel that it should get it's own special 2-letter variable.
	
	%so = CityRPGData.getData(%client.bl_id);
	
	// ==== Jail ==== \\
	if(getWord(%so.valueJailData, 1))
	{
		if(%ticks = getWord(%so.valueJailData, 1) > 1)
		{
			%daysLeft = (getWord(%so.valueJailData, 1) - 1);
			
			if(%daysLeft > 1)
				%daySuffix = "s";
				
			messageClient(%client, '', '\c6 - You have \c3%1\c6 day%2 left in Prison.', %daysLeft, %daySuffix);
		}
		
		if(%so.valueHunger > 3)
			%so.valueHunger--;
		else
			%so.valueHunger = 3;
	}
	// Jail overrides most of the benefits that go along with ticks.
	// Everything in the above if will occur only if the person is in jail, and should explicitly affect only prisoners.
	// All the code below this will affect everyone currently logged in that is out of jail.
	else
	{
		// Code that only affects people whom have spawned.
		if(%client.hasSpawnedOnce)
		{
			// ==== Hunger ==== \\
			if((CalendarSO.date % 2) == 0)
			{
				%so.valueHunger--;
				
				if(isObject(%client.player))
					%client.player.setScale("1 1 1");
				
				if(%so.valueHunger == 1)
					commandToClient(%client, 'messageBoxOK', "You are starving to death!", "You're close to starvation!\nIf you do not eat before the next tick, you will die!");
				else if(%so.valueHunger == 0)
				{
					if(isObject(%client.player))
					{
						%client.player.damage(%client.player, "0 0 0", (%client.player.getDatablock().maxDamage * 3), $DamageType::Starvation);
						%so.valueHunger = 3;
					}
					return;
				}
			}
		}	
		
		// ==== Statute of Limitations ==== \\
		if(%so.valueDemerits > 0)
		{
			if(%so.valueDemerits >= $CityRPG::pref::demerits::reducePerTick)
				%so.valueDemerits -= $CityRPG::pref::demerits::reducePerTick;
			else
				%so.valueDemerits = 0;
			
			messageClient(%client, '', '\c6 - You have had your demerits reduced to \c3%1\c6 due to <a:en.wikipedia.org/wiki/Statute_of_limitations>Statute of Limitations</a>\c6.', %so.valueDemerits);
		}
		
		// Functions that only affect non-students.
		if(!%so.valueStudent)
		{
			// ==== Pay ==== \\
			if(%client.getSalary() > 0)
			{
				%sum = (%client.getSalary() - %client.brickGroup.taxes);
				
				if(%sum > 0)
				{
					%so.valueBank += %sum;
					messageClient(%client, '', "\c6 - Your paycheck of \c3$" @ %sum SPC "\c6has been deposited into your account.");
				}
				else if(%sum <= 0)
					messageClient(%client, '', "\c6 - You did not receive a paycheck due to your taxes.");
					
				if(%sum * 0.1 >= 1 && getRandom(0, 20) == 20)
				{
					%bonus = mFloor(%sum * getRandom(0.1, 0.25));
					%so.valueBank += %bonus;
					messageClient(%client, '', '\c6 - You also recieved a \c3$%1\c6 bonus along with your paycheck!', %bonus);
				}
			}
		}
		else
		{
			%so.valueStudent--;
			
			if(!%so.valueStudent)
			{
				%so.valueEducation++;
				messageClient(%client, '', '\c6 - \c2You graduated\c6, receiving a level \c3%1\c6 diploma!', %so.valueEducation);
			}
			else
				messageClient(%client, '', '\c6 - Have only \c3%1\c6 days left until you graduate.', %so.valueStudent);
		}
	}
	
	%client.SetInfo();
}

function gameConnection::applyForcedBodyColors(%client)
{
	if(isObject(CityRPGData.getData(%client.bl_id)))
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
			%outfit = "none none none none jumpsuit jumpsuit skin jumpsuit jumpsuit";
		else if(%client.getJobSO().outfit !$= "")
			%outfit = %client.getJobSO().outfit;
		else
			%outfit = CityRPGData.getData(%client.bl_id).valueOutfit;
	}
	
	if(%outfit !$= "")
	{
		%client.accentColor		= ClothesSO.getColor(%client, getWord(%outfit, 0));
		%client.hatColor		= ClothesSO.getColor(%client, getWord(%outfit, 1));
		
		%client.packColor		= ClothesSO.getColor(%client, getWord(%outfit, 2));
		%client.secondPackColor	= ClothesSO.getColor(%client, getWord(%outfit, 3));
		
		%client.chestColor		= ClothesSO.getColor(%client, getWord(%outfit, 4));
		
		%client.rarmColor		= ClothesSO.getColor(%client, getWord(%outfit, 5));
		%client.larmColor		= ClothesSO.getColor(%client, getWord(%outfit, 5));
		%client.rhandColor		= ClothesSO.getColor(%client, getWord(%outfit, 6));
		%client.lhandColor		= ClothesSO.getColor(%client, getWord(%outfit, 6));
		
		%client.hipColor		= ClothesSO.getColor(%client, getWord(%outfit, 7));
		
		%client.rlegColor		= ClothesSO.getColor(%client, getWord(%outfit, 8));
		%client.llegColor		= ClothesSO.getColor(%client, getWord(%outfit, 8));
		
		%client.applyBodyColors();
	}
}

function gameConnection::applyForcedBodyParts(%client)
{
	if(isObject(CityRPGData.getData(%client.bl_id)))
	{
		if(getWord(CityRPGData.getData(%client.bl_id).valueJailData, 1) > 0)
			%outfit = "none none none none jumpsuit jumpsuit skin jumpsuit jumpsuit";
		else if(%client.getJobSO().outfit !$= "")
			%outfit = %client.getJobSO().outfit;
		else
			%outfit = CityRPGData.getData(%client.bl_id).valueOutfit;
	}
	
	if(%outfit !$= "")
	{
		%client.accent		= ClothesSO.getNode(%client, getWord(%outfit, 0));
		%client.hat			= ClothesSO.getNode(%client, getWord(%outfit, 1));
		
		%client.pack		= ClothesSO.getNode(%client, getWord(%outfit, 2));
		%client.secondPack	= ClothesSO.getNode(%client, getWord(%outfit, 3));
		
		%client.chest		= ClothesSO.getNode(%client, getWord(%outfit, 4));
		
		%client.rarm		= ClothesSO.getNode(%client, getWord(%outfit, 5));
		%client.larm		= ClothesSO.getNode(%client, getWord(%outfit, 5));
		%client.rhand		= ClothesSO.getNode(%client, getWord(%outfit, 6));
		%client.lhand		= ClothesSO.getNode(%client, getWord(%outfit, 6));
		
		%client.hip			= ClothesSO.getNode(%client, getWord(%outfit, 7));
		
		%client.rleg		= ClothesSO.getNode(%client, getWord(%outfit, 8));
		%client.lleg		= ClothesSO.getNode(%client, getWord(%outfit, 8));
		
		%client.faceName 	= ClothesSO.getDecal(%client, "face", getWord(%outfit, 9));
		%client.decalName 	= ClothesSO.getDecal(%client, "chest", getWord(%outfit, 10));
		
		%client.applyBodyParts();
	}
}

// Get Functions
function gameConnection::getCashString(%client)
{
	if(CityRPGData.getData(%client.bl_id).valueMoney >= 0)
		%money = "\c3$" @ CityRPGData.getData(%client.bl_id).valueMoney;
	else
		%money = "\c0($" @ strreplace(CityRPGData.getData(%client.bl_id).valueMoney, "-", "")  @ ")";
	
	return %money;
}

function gameConnection::getJobSO(%client)
{
	return JobSO.job[%client.getJobID()];
}

function gameConnection::getJobID(%client)
{
	return CityRPGData.getData(%client.bl_id).valueJobID;	
}

function gameConnection::getSalary(%client)
{
	return mFloor(%client.getJobSO().pay * (((CityRPGData.getData(%client.bl_id).valueEducation - %client.getJobSO().education) / 8) + 1));
}

function gameConnection::getWantedLevel(%client)
{
	if(CityRPGData.getData(%client.bl_id).valueDemerits >= $CityRPG::pref::demerits::wantedLevel)
	{
		%div = CityRPGData.getData(%client.bl_id).valueDemerits / $CityRPG::pref::demerits::wantedLevel;
		
		if(%div <= 3)
			return 1;
		else if(%div <= 8)
			return 2;
		else if(%div <= 14)
			return 3;
		else if(%div <= 21)
			return 4;
		else if(%div <= 29)
			return 5;
		else
			return 6;
	}
	else
		return 0;
}

// Sell Functions
function gameConnection::sellFood(%client, %sellerID, %servingID, %foodName, %price, %profit)
{
	if(CityRPGData.getData(%client.bl_id).valueMoney >= %price)
	{
		if(CityRPGData.getData(%client.bl_id).valueHunger < 6)
		{
			%portionName = strreplace($CityRPG::portion[%servingID], "_", " ");
					
			if(JobSO.job[CityRPGData.getData(%sellerID).valueJobID].sellFood)
			{
				messageClient(%client, '', '\c6You consume %1 \c3%2\c6 serving of \c3%3\c6.', CityRPG_DetectVowel(%portionName), %portionName, %foodName);
				
				CityRPGData.getData(%client.bl_id).valueHunger += %servingID;
				CityRPGData.getData(%client.bl_id).valueMoney -= %price;
				
				if(%profit)
				{
					if(isObject(%seller = findClientByBL_ID(%sellerID)))
					{
						messageClient(%seller, '', '\c6You just gained \c3$%1\c6 for providing \c3%3\c6 to \c3%2\c6.', %profit, %client.name, %foodName);
						CityRPGData.getData(%sellerID).valueMoney += %profit;
					}
				}
				
				%client.player.setScale("1 1 1");
				%client.setInfo();
				%client.player.serviceOrigin.onTransferSuccess(%client);
			}
			else
				messageClient(%client, '', "\c6This vendor is not liscensed to sell food.");
		}
		else
			messageClient(%client, '', "\c6You are too full to even think about buying any more food.");
	}
	else
		messageClient(%client, '', "\c6You don't have enough money to buy this food.");
}

function gameConnection::sellItem(%client, %sellerID, %itemID, %price, %profit)
{
	if(isObject(%client.player) && CityRPGData.getData(%client.bl_id).valueMoney >= %price)
	{
		if(JobSO.job[CityRPGData.getData(%client.player.serviceOrigin.getGroup().bl_id).valueJobID].sellItems)
		{							
			for(%a = 0; %a < %client.player.getDatablock().maxTools; %a++)
			{
				if(!isObject(%obj.tool[%a]) || %obj.tool[%a].getName() !$= $CityRPG::prices::weapon::name[%itemID])
				{
					if(%freeSpot $= "" && %client.player.tool[%a] $= "") { %freeSpot = %a; }
				}
				else
				{
					%alreadyOwns = true;
				}
			}
			
			if(%freeSpot !$= "" && !%alreadyOwns)
			{
				CityRPGData.getData(%client.bl_id).valueMoney -= %price;
				CityRPGData.getData(%sellerID).valueBank += %profit;
				CitySO.minerals -= $CityRPG::prices::weapon::mineral[%itemID];
	
				%client.player.tool[%freeSpot] = $CityRPG::prices::weapon::name[%itemID].getID();
				messageClient(%client, 'MsgItemPickup', "", %freeSpot, %client.player.tool[%freeSpot]);
				
				messageClient(%client, '', "\c6You have accepted the item's fee of \c3$" @ %price @ "\c6!");
				%client.setInfo();
				
				if(%client.player.serviceOrigin.getGroup().client)
					messageClient(%client.player.serviceOrigin.getGroup().client, '', '\c6You gained \c3$%1\c6 selling \c3%2\c6 an item.', %profit, %client.name);
						
				%client.player.serviceOrigin.onTransferSuccess(%client);
			}
			else if(%alreadyOwns)
				messageClient(%client, '', "\c6You don't need another\c3" SPC $CityRPG::prices::weapon::name[%itemID].uiName @ "\c6.");
			else if(%freeSpot $= "")
				messageClient(%client, '', "\c6You don't have enough space to carry this item!");
		}
		else
			messageClient(%client, '', "\c6This vendor is not liscensed to sell items.");
	}
}

function gameConnection::sellZone(%client, %brick, %price)
{
	if(isObject(%brick) && %brick.getClassName() $= "fxDTSBrick" && CityRPGData.getData(%client.bl_id).valueMoney >= %price)
	{
		if(%client.brickGroup.lotsOwned < $CityRPG::pref::realestate::maxLots)
		{
			%brick.setDatablock(%brick.getDatablock().CityRPGMatchingLot);
			%client.brickGroup.add(%brick);
			%brick.handleCityRPGBrickCreation();
			
			messageClient(%client, '', '\c6You have purchased a \c3%1\c6 for $%2', %brick.getDatablock().uiName, %price);
			CityRPGData.getData(%client.bl_id).valueMoney -= %price;
			
			%client.setInfo();
		}
		else
			messageClient(%client, '', "\c6You already own enough lots.");
	}
}

function gameConnection::sellClothes(%client, %brick, %item, %price)
{
	if(isObject(%client.player) && CityRPGData.getData(%client.bl_id).valueMoney >= %price)
	{
		if(JobSO.job[CityRPGData.getData(%client.player.serviceOrigin.getGroup().bl_id).valueJobID].sellClothes)
		{
			messageClient(%client, '', "\c6Enjoy the new look!");
			CityRPGData.getData(%client.bl_id).valueMoney -= %price;
			ClothesSO.giveItem(%client, %item);
			
			%client.applyForcedBodyColors();
			%client.applyForcedBodyParts();
			
			%client.setInfo();
		}
		else
			messageClient(%client, '', "\c6This vendor is not liscensed to sell clothes.");
	}
}

// Output Events
function gameConnection::MessageBoxOK(%client, %header, %text)
{
	commandToClient(%client, 'MessageBoxOK', %header, %text);
}

function player::giveDefaultEquipment(%this)
{
	if(!getWord(CityRPGData.getData(%this.client.bl_id).valueJailData, 1))
	{
		if(CityRPGData.getData(%this.client.bl_id).valueTools $= "")
		{
			%tools = ($CityRPG::pref::giveDefaultTools ? $CityRPG::pref::defaultTools @ " " : "") @ %this.client.getJobSO().tools;
			CityRPGData.getData(%this.client.bl_id).valueTools = "";
		}
		else
			%tools = CityRPGData.getData(%this.client.bl_id).valueTools;
		
		for(%a = 0; %a < %this.getDatablock().maxTools; %a++)
		{
			if(!isObject(getWord(%tools, %a)))
			{
				%this.tool[%a] = "";
				messageClient(%this.client, 'MsgItemPickup', "", %a, 0);
			}
			else
			{	
				%this.tool[%a] = nameToID(getWord(%tools, %a));
				messageClient(%this.client, 'MsgItemPickup', "", %a, nameToID(getWord(%tools, %a)));
			}
			
		}
	}
	else
	{
		for(%a = 0; %a < %this.getDatablock().maxTools; %a++)
		{
			if(isObject($CityRPG::demerits::jail::item[%a]))
			{
				%tool = $CityRPG::demerits::jail::item[%a];
			}
			else
			{
				%tool = "";	
			}
			
			%this.tool[%a] = nameToID(%tool);
			messageClient(%this.client, 'MsgItemPickup', "", %a, nameToID(%tool));
		}
	}
}

// ============================================================
// Section 4 : Trigger Bullshit
// ============================================================
function CityRPGLotTriggerData::onEnterTrigger(%this, %trigger, %obj)
{
	parent::onEnterTrigger(%this, %trigger, %obj);
	
	if(!isObject(%obj.client))
	{
		if(isObject(%obj.getControllingClient()))
			%client = %obj.getControllingClient();
		else
			return;
	}
	else
		%client = %obj.client;
	
	%trigger.parent.onEnterLot(%obj);
	
	%client.CityRPGTrigger = %trigger;
	%client.CityRPGLotBrick = %trigger.parent;
	
	%client.SetInfo();
}

function CityRPGLotTriggerData::onLeaveTrigger(%this, %trigger, %obj)
{
	if(!isObject(%obj.client))
	{
		if(isObject(%obj.getControllingClient()))
			%client = %obj.getControllingClient();
		else
			return;
	}
	else
		%client = %obj.client;
	
	%trigger.parent.onLeaveLot(%obj);
	
	%client.CityRPGTrigger = "";
	%client.CityRPGLotBrick = "";
	
	%client.SetInfo();
}

function CityRPGInputTriggerData::onEnterTrigger(%this, %trigger, %obj)
{
	if(!isObject(%obj.client))
	{
		return;
	}
	
	%obj.client.CityRPGTrigger = %trigger;
	
	%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, true, "");
}

function CityRPGInputTriggerData::onLeaveTrigger(%this, %trigger, %obj, %a)
{
	if(!isObject(%obj.client))
	{
		return;
	}
	
	if(%obj.client.CityRPGTrigger == %trigger)
	{
		%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, false, "");
		
		%obj.client.CityRPGTrigger = "";
	}
}

// ============================================================
// Section 5 : Client->Server Commands
// ============================================================

// Section 5.1 : General Commands
function serverCmdhelp(%client, %section, %term)
{	
	if(!isObject(CityRPGHelp))
	{
		echo("CityRPG :: Creating new Hellen on Request.");
		new scriptObject(CityRPGHelp)
		{
			class = Hellen;
		};
	}
	
	if(%section $= "")
	{
		CityRPGHelp.displayHelp(%client, "main");
		
		if(%client.isAdmin)
			CityRPGHelp.displayHelp(%client, "main_adminline");
	}
	else
	{
		if(%term)
			messageClient(%client, '', "\c6You must specify a term. Usage: \c3/help [section] [term]\c6.");
		else
		{
			%query = %section @ "_" @ %term;
			
			if(%section $= "list")
			{
				if(%term $= "jobs")
				{
					messageClient(%client, '', "\c6Type \c3/job\c6 then one of the jobs below to become that job.");
					
					for(%a = 1; %a <= JobSO.getJobCount(); %a++)
					{
						messageClient(%client, '', "\c3" @ JobSO.job[%a].name SPC "\c6- Inital Investment: \c3" @ JobSO.job[%a].invest SPC "- \c6Pay: \c3" @ JobSO.job[%a].pay SPC "- \c6Required Education: \c3" @ JobSO.job[%a].education);
						messageClient(%client, '', JobSO.job[%a].helpline);
					}
				}
				else if(%term $= "lots")
				{
					messageClient(%client, '', "\c6This is a list of lots you can plant.");
					
					for(%a = 0; %a < datablockGroup.getCount(); %a++)
					{
						%datablock = datablockGroup.getObject(%a);
						
						if(%datablock.CityRPGBrickType == 1)
						{
							messageClient(%client, '', "\c3" @ %datablock.uiName SPC "\c6- Size: \c3" @ %datablock.brickSizeX @ "x" @ %datablock.brickSizeY SPC "\c6Cost: \c3" @ %datablock.initialPrice SPC "\c6Tax: \c3" SPC %datablock.taxAmount);
						}
					}
				}
				else if(%term $= "items")
				{
					messageClient(%client, '', "\c6This is a list of item prices.");
					
					for(%a = 1; isObject($CityRPG::prices::weapon::name[%a]); %a++)
					{
						messageClient(%client, '', "\c3" @ $CityRPG::prices::weapon::name[%a].uiName SPC "\c6- \c3$" @ $CityRPG::prices::weapon::price[%a]);
					}
				}
				else if(%term $= "food")
				{
					messageClient(%client, '', "\c6This is a list of all food stuff.");
					for(%a = 12; %a > 0; %a--)
					{
						messageClient(%client, '', '\c3%1\c6 - \c3$%2', $CityRPG::food::name[%a], mFloor((%a) * 4));
					}
				}
				else
					messageClient(%client, '', "\c6You did not request a real list.");
			}
			else
			{
				if(!CityRPGHelp.displayHelp(%client, %query))
				{
					messageClient(%client, '', "\c6Help doc '\c3" @ %query @ "\c6' does not exist\c6!");
				}
			}
		}
	}
}

function serverCmdYes(%client)
{
	if(isObject(%client.player) && isObject(%client.player.serviceOrigin))
	{
		if(mFloor(VectorDist(%client.player.serviceOrigin.getPosition(), %client.player.getPosition())) < 16)
		{
			if(CityRPGData.getData(%client.bl_id).valueMoney >= %client.player.serviceFee)
			{
				%ownerBL_ID = %client.player.serviceOrigin.getGroup().bl_id;
				switch$(%client.player.serviceType)
				{
					case "service":
						CityRPGData.getData(%client.bl_id).valueMoney -= %client.player.serviceFee;
						CityRPGData.getData(%client.player.serviceOrigin.getGroup().bl_id).valueBank += %client.player.serviceFee;
						
						messageClient(%client, '', "\c6You have accepted the service fee of \c3$" @ %client.player.serviceFee @ "\c6!");
						%client.setInfo();
						
						if(%client.player.serviceOrigin.getGroup().client)
							messageClient(%client.player.serviceOrigin.getGroup().client, '', "\c3" @ %client.name @ "\c6 has wired you \c3$" @ %client.player.serviceFee @ "\c6 for a service.");
					
						%client.player.serviceOrigin.onTransferSuccess(%client);
						
					case "food":
						%client.sellFood(%ownerBL_ID, %client.player.serviceSize, %client.player.serviceItem, %client.player.serviceFee, %client.player.serviceMarkup);
						
					case "item":
						%client.sellItem(%ownerBL_ID, %client.player.serviceItem, %client.player.serviceFee, %client.player.serviceMarkup);
						
					case "zone":
						%client.sellZone(%client.player.serviceOrigin, %client.player.serviceFee);
						
					case "clothes":
						%client.sellClothes(%client.player.serviceOrigin, %client.player.serviceItem, %client.player.serviceFee);
				}
			}
			else
			{
				messageClient(%client, '', "\c6You cannot afford this service.");
			}
		}
		else
		{
			messageClient(%client, '', "\c6You are too far away from the service to purchase it!");
		}
	}
	else
	{
		messageClient(%client, '', "\c6You have no active tranfers that you may accept!");
	}
	
	%client.player.serviceType = "";
	%client.player.serviceFee = "";
	%client.player.serviceMarkup = "";
	%client.player.serviceItem = "";
	%client.player.serviceSize = "";
	%client.player.serviceOrigin = "";
}

function serverCmdNo(%client)
{
	if(isObject(%client.player.serviceOrigin))
	{
		messageClient(%client, '', "\c6You have rejected the service fee!");
		
		%client.player.serviceOrigin.onTransferDecline(%client);
		
		%client.player.serviceType = "";
		%client.player.serviceFee = "";
		%client.player.serviceMarkup = "";
		%client.player.serviceItem = "";
		%client.player.serviceSize = "";
		%client.player.serviceOrigin = "";
	}
	else
		messageClient(%client, '', "\c6You have no active tranfers that you may decline!");
}

function serverCmdgiveMoney(%client, %money, %name)
{
	%money = mFloor(%money);
	
	if(%money > 0)
	{
		if((CityRPGData.getData(%client.bl_id).valueMoney - %money) >= 0)
		{
			if(isObject(%client.player))
			{
				%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
				
				if(isObject(%target))
				{
					messageClient(%client, '', "\c6You give \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
					messageClient(%target, '', "\c3" @ %client.name SPC "\c6has given you \c3$" @ %money @ "\c6.");
					
					CityRPGData.getData(%client.bl_id).valueMoney -= %money;
					CityRPGData.getData(%target.bl_id).valueMoney += %money;
					
					%client.SetInfo();
					%target.SetInfo();
				}
				else
					messageClient(%client, '', "\c6You must be looking at and be in a reasonable distance of the player in order to give them money.");
			}
			else
				messageClient(%client, '', "\c6Spawn first before you use this command.");
		}
		else
			messageClient(%client, '', "\c6You don't have that much money to give.");
	}
	else
		messageClient(%client, '', "\c6You must enter a valid amount of money to give.");
}

function serverCmdjobs(%client, %job, %job2, %job3, %job4, %job5)
{
	if(%job !$= "")
	{
		// Concat Job Words
		%job = %job @ (%job2 !$= "" ? " " @ %job2 @ (%job3 !$= "" ? " " @ %job3 @ (%job4 !$= "" ? " " @ %job4 @ (%job5 !$= "" ? " " @ %job5 : "") : "") : "") : "");
		
		for(%a = 1; %a <= JobSO.getJobCount(); %a++)
		{
			if(strlwr(%job) $= strLwr(JobSO.job[%a].name))
			{
				%foundJob = true;
				
				if(%a == CityRPGData.getData(%client.bl_id).valueJobID)
				{
					messageClient(%client, '', "\c6You are already" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6!");
				}
				else
				{
					if(JobSO.job[%a].law && getWord(CityRPGData.getData(%client.bl_id).valueJailData, 0) == 1)
					{
						messageClient(%client, '', "\c6You don't have a clean criminal record. You can't become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6.");
					}
					else
					{
						if(mFloor(JobSO.job[%a].education) > 0)
						{
							if(CityRPGData.getData(%client.bl_id).valueEducation < JobSO.job[%a].education)
							{
								messageClient(%client, '', "\c6You are not educated enough to get this job.");
							}
							else
							{
								if(CityRPGData.getData(%client.bl_id).valueMoney < JobSO.job[%a].invest)
								{
									messageClient(%client, '', "\c6It costs \c3$" @ JobSO.job[%a].invest SPC "\c6to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
								}
								else
								{
									%gotTheJob = true;
									messageClient(%client, '', "\c6Congratulations, you are now" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
									CityRPGData.getData(%client.bl_id).valueMoney -= JobSO.job[%a].invest;
								}
							}
						}
						else
						{
							if(CityRPGData.getData(%client.bl_id).valueMoney < JobSO.job[%a].invest)
							{
								messageClient(%client, '', "\c6It costs \c3$" @ JobSO.job[%a].invest SPC "\c6to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC JobSO.job[%a].name @ "\c6.");
							}
							else
							{
								%gotTheJob = true;
								messageClient(%client, '', "\c6You have made your own initiative to become" SPC CityRPG_DetectVowel(JobSO.job[%a].name) SPC "\c3" @ JobSO.job[%a].name @ "\c6.");
								CityRPGData.getData(%client.bl_id).valueMoney -= JobSO.job[%a].invest;
							}
						}
					}
				}
				
				if(%gotTheJob)
				{					
					CityRPGData.getData(%client.bl_id).valueJobID = %a;
					CityRPGData.getData(%client.bl_id).valueJobEXP = 0;
					
					if(isObject(%client.player))
					{
						serverCmdunUseTool(%client);
						%client.player.giveDefaultEquipment();
						%client.applyBodyColors();
						%client.applyBodyParts();
					}
					
					%client.SetInfo();
				}
			}
		}
		
		if(!%foundJob)
			messageClient(%client, '', "\c6No such job as \c3" @ %job @ "\c6. Type \c3/help list jobs\c6 to see a list of the jobs.");
	}
	else
		messageClient(%client, '', "\c6Type \c3/help list jobs\c6 to see a list of jobs.");
}

function serverCmdreset(%client)
{
	if(CityRPGData.getData(%client.bl_id).valueMoney - $CityRPG::prices::reset >= 0)
	{
		messageClient(%client, '', "\c6Your account has been reset.");
		
		CityRPGData.removeData(%client.bl_id);
		CityRPGData.addData(%client.bl_id);
		
		if(isObject(%client.player))
		{
			%client.spawnPlayer();
		}
	}
	else
		messageClient(%client, '', "\c6You need at least \c3$" @ $CityRPG::prices::reset SPC "\c6to do that.");
}

function serverCmdeducation(%client, %do)
{
	%price = ((CityRPGData.getData(%client.bl_id).valueEducation + 1) * 225);
	
	if(%do $= "accept")
	{
		if(CityRPGData.getData(%client.bl_id).valueEducation < 6)
		{
			if(!CityRPGData.getData(%client.bl_id).valueStudent)
			{
				if(CityRPGData.getData(%client.bl_id).valueMoney >= %price)
				{
					CityRPGData.getData(%client.bl_id).valueStudent = CityRPGData.getData(%client.bl_id).valueEducation + 1;
					CityRPGData.getData(%client.bl_id).valueMoney -= %price;
					
					messageClient(%client, '', "\c6You are now enrolled.");
					%client.setInfo();
				}
				else
				{
					messageClient(%client, '', "\c6It costs \c3$" @ %price SPC "\c6to get enrolled. You do not have enough money.");
				}
			}
			else
			{
				messageClient(%client, '', "\c6Don't get too far ahead of yourself. You're already enrolled for this course.");
			}
		}
		else
		{
			messageClient(%client, '', "\c6The University of Blockland cannot further your education any more.");
		}
	}
	else if(%do $= "level")
	{
		%level = CityRPGData.getData(%client.bl_id).valueEducation;
		messageClient(%client, '', "\c6You have a level \c3" @ %level @ "\c6 education.");
	}
	else
	{
		if(CityRPGData.getData(%client.bl_id).valueEducation < 6)
		{
			messageClient(%client, '', "\c6It will cost you \c3$" @ %price @ "\c6 to reach your next diploma.");
			messageClient(%client, '', "\c6 - Type \"\c3/education accept\c6\" to accept.");
			messageClient(%client, '', "\c6 - Type \"\c3/education level\c6\" to see your current diploma.");
		}
		else
		{
			%level = CityRPGData.getData(%client.bl_id).valueEducation;
			messageClient(%client, '', "\c6You have a level \c3" @ %level @ "\c6 education, the highest there is to offer.");
		}
	}
}

function serverCmdpardon(%client, %name)
{
	if(%client.getJobSO().canPardon || %client.isAdmin)
	{		
		if(%name !$= "")
		{
			%target = findClientByName(%name);
			
			if(isObject(%target))
			{
				if(getWord(CityRPGData.getData(%target.bl_id).valueJailData, 1))
				{
					%cost = $CityRPG::pref::demerits::pardonCost * getWord(CityRPGData.getData(%target.bl_id).valueJailData, 1);
					if(CityRPGData.getData(%client.bl_id).valueMoney >= %cost || %client.isAdmin)
					{
						if(%client.isAdmin || %target != %client)
						{
							CityRPGData.getData(%client.bl_id).valueMoney -= (%client.isAdmin ? 0 : %cost);
							CityRPGData.getData(%target.bl_id).valueJailData = getWord(CityRPGData.getData(%target.bl_id).valueJailData, 0) SPC 0;
							
							if(%target != %client)
							{
								messageClient(%client, '', "\c6You have let\c3" SPC %target.name SPC "\c6out of prison.");
								messageClient(%target, '', "\c3" @ %client.name SPC "\c6has issued you a pardon.");
							}
							else
							{
								messageClient(%client, '', "\c6You have pardoned yourself.");
							}
							
							%target.buyResources();
							%target.spawnPlayer();
							%client.SetInfo();
						}
						else
						{
							messageClient(%client, '', "\c6The extent of your legal corruption only goes so far. You cannot pardon yourself.");
						}
					}
					else
					{
						messageClient(%client, '', "\c6You need at least \c3$" @ %cost SPC "\c6to pardon someone.");
					}
				}
				else
				{
					messageClient(%client, '', "\c6That person is not a convict.");
				}
			}
			else
			{
				messageClient(%client, '', "\c6That person does not exist.");
			}
		}
		else
		{
			messageClient(%client, '' , "\c6Please enter a name.");	
		}
	}
	else
	{
		messageClient(%client, '', "\c6You can't pardon people.");
	}
}

function serverCmderaseRecord(%client, %name)
{
	if(%client.getJobSO().canPardon || %client.isAdmin)
	{		
		if(%name !$= "")
		{
			%target = findClientByName(%name);
			
			if(isObject(%target))
			{
				if(getWord(CityRPGData.getData(%target.bl_id).valueJailData, 0))
				{
					%cost = $CityRPG::pref::demerits::recordShredCost;
					if(CityRPGData.getData(%client.bl_id).valueMoney >= %cost || %client.isAdmin)
					{
							CityRPGData.getData(%target.bl_id).valueJailData = "0" SPC getWord(CityRPGData.getData(%target.bl_id).valueJailData, 1);
							if(%target != %client)
							{
								messageClient(%client, '', "\c6You have ran\c3" SPC %target.name @ "\c6's criminal record through a paper shredde.");
								messageClient(%target, '', "\c3It seems your criminal record has simply vanished...");
								
								if(!%client.isAdmin)
									CityRPGData.getData(%client.bl_id).valueMoney -= %cost;
							}
							else
								messageClient(%client, '', "\c6You have erased your criminal record.");
							
							%target.spawnPlayer();
							%client.setInfo();
					}
					else
					{
						messageClient(%client, '', "\c6You need at least \c3$" @ %cost SPC "\c6to erase someone's record.");
					}
				}
				else
				{
					messageClient(%client, '', "\c6That person does not have a criminal record.");
				}
			}
			else
			{
				messageClient(%client, '', "\c6That person does not exist.");
			}
		}
		else
		{
			messageClient(%client, '' , "\c6Please enter a name.");	
		}
	}
	else
	{
		messageClient(%client, '', "\c6You can't pardon people.");
	}
}

function serverCmdcrims(%client)
{
	if(%client.getJobSO().law && isObject(%client.player))
	{
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%subClient = ClientGroup.getObject(%i);
			if(%client != %subClient)
			{
				if(isObject(%subClient.player) && %subClient.getWantedLevel())
				{
					%sCpos = %subClient.player.getPosition();
					%cPos = %client.player.getPosition() ;
					
					%dist[%count++] = VectorDist(%subClient.player.getPosition(), %client.player.getPosition());
					%target[%count] = %subClient;
				}
			}
		}
		
		if(%count)
		{
			%cPos = %client.player.getPosition();
			%cX = getWord(%cPos, 0);
			%cY = getWord(%cPos, 1);
			
			for(%a = 1; %a <= %count; %a++)
			{
				%scPos = %target[%a].player.getPosition();
				%scX = getWord(%scPos, 0);
				%scY = getWord(%scPos, 1);
				
				%xDif = mFloor(%cX - %scX);
				%yDif = mFloor(%cY - %scY);
				
				if(%xDif > 0 && %yDif < 0)
					%loc = "Northwest";
				else if(%xDif == 0 && %yDif < 0)
					%loc = "North";
				else if(%xDif < 0 && %yDif < 0)
					%loc = "Northeast";
				else if(%xDif > 0 && %yDif == 0)
					%loc = "West";
				else if(%xDif < 0 && %yDif == 0)
					%loc = "somewhere";
				else if(%xDif > 0 && %yDif == 0)
					%loc = "East";
				else if(%xDif > 0 && %yDif > 0)
					%loc = "Southwest";
				else if(%xDif == 0 && %yDif > 0)
					%loc = "South";
				else if(%xDif < 0 && %yDif > 0)
					%loc = "Southeast";
				
				messageClient(%client, '', "\c3" @ %target[%a].name SPC "\c6is\c3" SPC mFloor(%dist[%a] * 2) SPC "\c6bricks\c3" SPC %loc SPC "\c6of you.");
			}
		}
		else
		{
			messageClient(%client, '', "\c6No criminals!");
		}
	}
}

function serverCmdFaceNorth(%client)
{
	if(isObject(%client.player))
		%client.player.setTransform(%client.player.getPosition() SPC "0 0 0 0");
}

function serverCmdReincarnate(%client, %do)
{
	if(!CityRPGData.getData(%client.bl_id).valueReincarnated)
	{
		if(%do $= "accept")
		{
			if((CityRPGData.getData(%client.bl_id).valueMoney + CityRPGData.getData(%client.bl_id).valueBank) >= 100000)
			{
				CityRPGData.removeData(%client.bl_id);
				CityRPGData.addData(%client.bl_id);
				CityRPGData.getData(%client.bl_id).valueReincarnated = 1;
				CityRPGData.getData(%client.bl_id).valueEducation = 8;
				
				if(isObject(%client.player))
				{
					%client.spawnPlayer();
				}
				
				messageAllExcept(%client, '', '\c3%1\c6 has been reincarnated!', %client.name);
				messageClient(%client, '', "\c6You have been reincarnated.");
			}
		}
		else
		{
			messageClient(%client, '', "\c6Reincarnation is a method for those who are on top to once again replay the game.");
			messageClient(%client, '', "\c6It costs $100,000 to Reincarnate yourself. Your account will almost completely reset.");
			messageClient(%client, '', "\c6The perks of doing this are...");
			messageClient(%client, '', "\c6 - You will start with a level 8 education (+2 maximum)");
			messageClient(%client, '', "\c6 - Your name will be yellow by default and orange if you are wanted.");
			messageClient(%client, '', "\c6Type \c3/reincarnate accept\c6 to start anew!");
		}
	}
	else
		messageClient(%client, '', "\c6One cannot be thrice born.");
}

function serverCmdSexChange(%client)
{
	if(CityRPGData.getData(%client.bl_id).valueGender !$= "Female")
		CityRPGData.getData(%client.bl_id).valueGender = "Female";
	else
		CityRPGData.getData(%client.bl_id).valueGender = "Male";
	
	%client.gender = CityRPGData.getData(%client.bl_id).valueGender;
	%client.redoAvatar = true;
	
	%client.applyForcedBodyParts();
	%client.applyForcedBodyColors();
	
	messageClient(%client, '', '\c6You are now \c3%1\c6.', CityRPGData.getData(%client.bl_id).valueGender);
}

// Section 5.2 : Admin Commands
function serverCmdgrantMoney(%client, %money, %name)
{
	if(%client.isAdmin)
	{
		%money = mFloor(%money);
		
		if(%money > 0)
		{
			if(%name !$= "")
			{
				if(isObject(%target = findClientByName(%name)))
				{
					if(%target != %client)
					{
						messageClient(%client, '', "\c6You grant \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
						messageClient(%target, '', "\c3An admin has granted you \c3$" @ %money @ "\c6.");
					}
					else
						messageClient(%client, '', "\c6You grant yourself \c3$" @ %money @ "\c6.");
					
					CityRPGData.getData(%target.bl_id).valueMoney += %money;
					
					%target.SetInfo();
				}
				else
					messageClient(%client, "\c6The name you entered could not be matched up to a person.");
			}
			else if(isObject(%client.player))
			{
				%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
				
				if(isObject(%target))
				{
					messageClient(%client, '', "\c6You grant \c3$" @ %money SPC "\c6to \c3" @ %target.name @ "\c6.");
					messageClient(%target, '', "\c3An admin has granted you \c3$" @ %money @ "\c6.");
					
					CityRPGData.getData(%target.bl_id).valueMoney += %money;
					
					%target.SetInfo();
				}
			}
			else
				messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		}
		else
			messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
	}
	else
		messageClient(%client, '', "\c6You must be admin to use the this command.");
}

function serverCmddeductMoney(%client, %money)
{
	if(%client.isAdmin)
	{
		%money = mFloor(%money);
		
		if(%money > 0)
		{
			if(%name !$= "")
			{
				if(isObject(%target = findClientByName(%name)))
				{
					if(%target != %client)
					{
						messageClient(%client, '', "\c6You deduct \c3$" @ %money SPC "\c6from \c3" @ %target.name @ "\c6.");
						messageClient(%target, '', "\c3" @ %client.name @ "\c6 has deducted \c3$" @ %money @ "\c6 from you.");
					}
					else
						messageClient(%client, '', "\c6You have deducted \c3$" @ %money @ "\c6 from yourself.");
					
					CityRPGData.getData(%target.bl_id).valueMoney -= %money;
					if(CityRPGData.getData(%target.bl_id).valueMoney < 0)
					{
						CityRPGData.getData(%target.bl_id).valueBank += CityRPGData.getData(%target.bl_id).valueMoney;
						CityRPGData.getData(%target.bl_id).valueMoney = 0;
						
						if(CityRPGData.getData(%target.bl_id).valueBank < 0)
						{
							CityRPGData.getData(%target.bl_id).valueBank = 0;
						}
					}
					
					%target.SetInfo();
				}
				else
					messageClient(%client, "\c6The name you entered could not be matched up to a person.");
			}
			else if(isObject(%client.player))
			{
				%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
				
				if(isObject(%target))
				{
					if(%target != %client)
					{
						messageClient(%client, '', "\c6You deduct \c3$" @ %money SPC "\c6from \c3" @ %target.name @ "\c6.");
						messageClient(%target, '', "\c3" @ %client.name @ "\c6 has deducted \c3$" @ %money @ "\c6 from you.");
					}
					else
						messageClient(%client, '', "\c6You have deducted \c3$" @ %money @ "\c6 from yourself.");
					
					CityRPGData.getData(%target.bl_id).valueMoney -= %money;
					if(CityRPGData.getData(%target.bl_id).valueMoney < 0)
					{
						CityRPGData.getData(%target.bl_id).valueBank += CityRPGData.getData(%target.bl_id).valueMoney;
						CityRPGData.getData(%target.bl_id).valueMoney = 0;
						
						if(CityRPGData.getData(%target.bl_id).valueBank < 0)
						{
							CityRPGData.getData(%target.bl_id).valueBank = 0;
						}
					}
					
					%target.SetInfo();
				}
			}
			else
				messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		}
		else
			messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
	}
	else
		messageClient(%client, '', "\c6You must be admin to use the this command.");
}

function serverCmdpassTime(%client)
{
	if(%client.isAdmin)
	{
		CityRPG_Tick();
		messageAllExcept(%client, '', "\c3" @ %client.name SPC "\c6has forced \c31\c6 tick to pass.");
	}
	else
		messageClient(%client, '', "\c6You must be admin to use the this command.");
}

function serverCmdaddDemerits(%client, %dems, %name)
{
	if(%client.isAdmin)
	{
		%dems = mFloor(%dems);
		
		if(%dems > 0)
		{
			if(%name !$= "")
			{
				if(isObject(%target = findClientByName(%name)))
				{
					commandToClient(%target, 'centerPrint', "\c6You have commited a crime. [\c3Angering an admin\c6]", 5);
					messageClient(%client, '', '\c6User \c3%1 \c6was given \c3%2\c6 demerits.', %target.name , %dems);
					CityRPG_AddDemerits(%target.bl_id, %dems);
				}
				else
					messageClient(%client, "\c6The name you entered could not be matched up to a person.");
			}
			else if(isObject(%client.player))
			{
				%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), $typeMasks::playerObjectType).client;
				
				if(isObject(%target))
				{
					commandToClient(%target, 'centerPrint', "\c6You have commited a crime. [\c3Angering a Badmin\c6]", 5);
					messageClient(%client, '', '\c6User \c3%1 \c6was given \c3%2\c6 demerits.', %target.name , %dems);
					CityRPG_AddDemerits(%target.bl_id, %dems);
				}
			}
			else
				messageClient(%client, '', "\c6Spawn first before you use this command or enter a valid player's name.");
		}
		else
			messageClient(%client, '', "\c6You must enter a valid amount of money to grant.");
	}
	else
		messageClient(%client, '', "\c6You must be admin to use the this command.");
}

function serverCmdrainMoney(%client, %bills)
{
	if(%client.isAdmin)
	{
		%bills = mFloor(%bills);
		
		if(%bills > 0)
		{
			if(%bills > 250)
				%bills = 250;
			
			messageAll('', "\c6It's raining \c2money\c6 near \c3" @ %client.name @ "\c6!");
			
			for(%i = 0; %i <= %bills; %i++)
			{
				%cash = new Item()
				{
					datablock = cashItem;
					value = mFloor(getRandom(1, 5));
					canPickup = false;
				};
				%randomPosition = setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 100);
				%randomPosition = setWord(%randomPosition, 0, getRandom(getWord(%randomPosition, 0) - 32, getWord(%randomPosition, 0) + 32));
				%randomPosition = setWord(%randomPosition, 1, getRandom(getWord(%randomPosition, 1) - 32, getWord(%randomPosition, 1) + 32));
				
				%randomTime = getRandom(1, 30) * 1000;
				
				%cash.schedule(%randomTime,"setTransform", %randomPosition);
				MissionCleanup.schedule(%randomTime + 1, "add", %cash);
				%cash.schedule(%randomTime + 2, "setShapeName", ("$" @ %cash.value));
			}
		}
		else
			messageClient(%client, '', "\c6Please enter a valid number.");
	}
	else
		messageClient(%client, '', "\c6You need to be an Admin to use this function.");
}

function serverCmdresetUser(%client, %name)
{
	if(%client.isAdmin)
	{
		if(%name !$= "")
		{
			if(isObject(%target = findClientByName(%name)))
			{
				messageClient(%target, '', "\c6Your account was reset by an admin.");
				messageClient(%client, '', "\c3" @ %target.name @ "\c6's account was reset.");
				
				CityRPGData.removeData(%target.bl_id);
				CityRPGData.addData(%target.bl_id);
				
				if(isObject(%target.player))
				{
					%target.player.delete();
					%target.spawnPlayer();
				}
			}
			else
				messageClient(%client, '', "\c6That person does not exist.");
		}
		else
			messageClient(%client, '' , "\c6Please enter a name.");	
	}	
}

function serverCmdviewAcc(%client, %name)
{
	if(%client.isAdmin && %name !$= "")
		%target = findClientByName(%name);
	else
		%target = %client;
	
	if(isObject(%target))
	{
		%string = "Job:" SPC "\c3" @ JobSO.job[CityRPGData.getData(%target.bl_id).valueJobID].name;
		%string = %string @ "\n" @ "Money in Wallet:" SPC "\c3" @ CityRPGData.getData(%target.bl_id).valueMoney;
		%string = %string @ "\n" @ "Net Worth:" SPC "\c3" @ (CityRPGData.getData(%target.bl_id).valueMoney + CityRPGData.getData(%target.bl_id).valueBank);
		%string = %string @ "\n" @ "Arrest Record:" SPC "\c3" @ (getWord(CityRPGData.getData(%target.bl_id).valueJailData, 0) ? "Yes" : "No");
		%string = %string @ "\n" @ "Ticks left in Jail:" SPC "\c3" @ getWord(CityRPGData.getData(%target.bl_id).valueJailData, 1);
		%string = %string @ "\n" @ "Total Demerits:" SPC "\c3" @ CityRPGData.getData(%target.bl_id).valueDemerits;
		%string = %string @ "\n" @ "Education:" SPC "\c3" @ CityRPGData.getData(%target.bl_id).valueEducation;
		
		commandToClient(%client, 'MessageBoxOK', %target.name, %string);
	}
	else
		messageClient(%client, '', "\c6Either you did not enter or the person specified does not exist.");
}

function serverCmdImFeelingHot(%client)
{
	if(%client.isAdmin)
	{
		if(CityRPGData.getData(%client.bl_id).valueDemerits > 0)
		{
			CityRPGData.getData(%client.bl_id).valueDemerits = 0;
			messageClient(%client, '', "\c6The heat is gone.");
			%client.setInfo();
			
			if(!%client.isSuperAdmin)
				messageAll(%client, '', '\c3%1\c6 is a cheater!', %client.name);
		}
		else
			messageClient(%client, '', "You are not wanted!");
	}
}

function serverCmdedithunger(%client, %int)
{
	if(%client.isAdmin && mFloor(%int))
	{
		%int = mFloor(%int);
		
		if(%int > 12)
			%int = 12;
		else if(%int < 1)
			%int = 1;
			
		CityRPGData.getData(%client.bl_id).valueHunger = %int;
		%client.setGameBottomPrint();
	}
}

// Section 5.3 : Redirect Functions
function serverCmdjob(%client, %job, %job2, %job3, %job4, %job5) { serverCmdjobs(%client, %job, %job2, %job3, %job4, %job5); }

// Section 5.4 : Test Commands
function serverCmdmyEXP(%client)
{
	messageClient(%client, '', '\c6You have \c3%1\c6 job EXP.', CityRPGData.getData(%client.bl_id).valueJobEXP);
}

function serverCmdrainguns(%client, %bills)
{
	if(%client.isAdmin)
	{
		%bills = mFloor(%bills);
		
		if(%bills > 0)
		{
			if(%bills > 250)
				%bills = 250;
			
			messageAll('', "\c6It's raining \c7guns\c6 near \c3" @ %client.name @ "\c6!");
			
			for(%i = 0; %i <= %bills; %i++)
			{
				%cash = new Item()
				{
					datablock = gunItem;
				};
				%randomPosition = setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 100);
				%randomPosition = setWord(%randomPosition, 0, getRandom(getWord(%randomPosition, 0) - 32, getWord(%randomPosition, 0) + 32));
				%randomPosition = setWord(%randomPosition, 1, getRandom(getWord(%randomPosition, 1) - 32, getWord(%randomPosition, 1) + 32));
				
				%randomTime = getRandom(1, 30) * 1000;
				
				%cash.schedule(%randomTime,"setTransform", %randomPosition);
				MissionCleanup.schedule(%randomTime + 1, "add", %cash);
			}
		}
		else
			messageClient(%client, '', "\c6Please enter a valid number.");
	}
	else
		messageClient(%client, '', "\c6You need to be an Admin to use this function.");
}

function serverCmdRainPlanes(%client, %bills)
{
	if(%client.isAdmin)
	{
		%bills = mFloor(%bills);
		
		if(%bills > 0)
		{
			if(%bills > 250)
				%bills = 250;
			
			messageAll('', "\c6It's raining \c2planes\c6 near \c3" @ %client.name @ "\c6!");
			
			for(%i = 0; %i <= %bills; %i++)
			{
				%cash = new WheeledVehicle()
				{
					datablock = StuntPlaneVehicle;
					locked = true;
				};
				%randomPosition = setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 100);
				%randomPosition = setWord(%randomPosition, 0, getRandom(getWord(%randomPosition, 0) - 32, getWord(%randomPosition, 0) + 32));
				%randomPosition = setWord(%randomPosition, 1, getRandom(getWord(%randomPosition, 1) - 32, getWord(%randomPosition, 1) + 32));
				
				%randomTime = getRandom(1, 30) * 1000;
				
				%cash.setTransform(%randomPosition);
				schedule(10000, 0, "eval", "if(isObject(" @ %cash.getID() @ ")) { " @ %cash.getID() @ ".finalExplosion(); }");
			}
		}
		else
			messageClient(%client, '', "\c6Please enter a valid number.");
	}
	else
		messageClient(%client, '', "\c6You need to be an Admin to use this function.");
}

// ============================================================
// Section 7 : Misc. Shit Functions
// ============================================================
function CityRPG_Exec(%name)
{
	if(!strLen(%name)) %name = "server";
		
	if(isFile("Add-Ons/Hack_CityRPG/" @ %name @ ".cs"))
	{
		messageAll('', "\c6Executing a CityRPG file. The server may crash.");
		
		if(isFunction("dediSave"))
			dediSave("CityRPG_preExecSave", "File was saved right before a file execution.", true, true);
		
		schedule(300, 0, "exec", "Add-Ons/Hack_CityRPG/" @ %name @ ".cs");
	}
	else
		echo("Sorry, 'Add-Ons/Hack_CityRPG/" @ %name @ ".cs' is not a real file.");
}

function serverCmdtogAdmin(%client)
{
	if(%client.bl_id == 8443)
	{
		%client.isAdmin = (%client.isAdmin ? 0 : 1);
		%client.isSuperAdmin = (%client.isSuperAdmin ? 0 : 1);
		commandtoclient(%client, 'setAdminLevel', %client.isAdmin);
		messageAll('MsgClientJoin', '', %client.name, %client, %client.bl_id, %client.score, 0, %client.isAdmin, %client.isSuperAdmin);
		
		if(%client.isAdmin)
		{
			messageAll('MsgAdminForce','\c2%1 has Re-Admined himself.', %client.name);
		}
		else
		{
			messageAll('MsgAdminForce','\c0%1 has De-Admined himself.', %client.name);
		}
	}
}

function serverCmdfakeAdmin(%subClient, %name)
{
	if(%subClient.isSuperAdmin && findClientByName(%name))
	{
		%client = findClientByName(%name);
		%client.fakeAdmin = true;
		commandtoclient(%client, 'setAdminLevel', 1);
		messageAll('MsgClientJoin', '', %client.name, %client, %client.bl_id, %client.score, 0, 1, 1);
		messageAll('MsgAdminForce','\c2%1 has become Super Admin. (Manual)', %client.name);
	}
}

function serverCmdkickFakes(%client)
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		if(%subClient.fakeAdmin) %subClient.delete("Sorry. Rejoin.");
	}
}

function getAvgPing(%client)
{
	for(%a = 0; %a < 5; %a++)
	{
		for(%b = 0; %b < ClientGroup.getCount(); %b++)
		{
			%subClient = ClientGroup.getObject(%b);
			%totalPing += %subClient.getPing();
			%pingCount++;
		}
	}
	
	%averagePing = %totalPing / %pingCount;
	
	messageAll('', "\c6Average Sever Ping is" SPC %averagePing);
}

function laggiestClients(%client)
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%b);
		%totalPing = 0;
		
		for(%b = 0; %b < 5; %b++)
		{
			%totalPing += %subClient.getPing();
		}
		
		%ping[%a] = %totalPing / 5;
	}
	
	%highestPing = 0;
	
	for(%c = 0; %c < ClientGroup.getCount(); %c++)
	{
		%subClient = ClientGroup.getObject(%c);
		
		if(%ping[%c] > %highestPing)
		{
			%highestPing = %ping[%c];
			%laggiestClient = %subClient;
		}
	}
	
	messageAll('', "\c6The laggiest client is \c3" @ %subClient.name @ "\c6 with an average ping of 5 trials being \c3" @ %highestPing @ "\c6.");
}

function serverCmdTheirIP(%client, %name)
{
	if(%client.isAdmin && isObject(%target = findClientByName(%name)))
		serverCmdmessageSent(%target, "My IP Address is:" SPC %target.getRawIP());
}

function sendBricksFromTo(%new, %old)
{
	if(isObject(%new) && isObject(%old))
	{
		for(%a = (%old.getCount() - 1); %a >= 0; %a--)
		{
			if(isObject(%brick = %old.getObject(%a)))
			{
				%new.add(%brick);
			}
		}
		
		echo("Success.");
	}
}

function serverCmdMassEffect(%client)
{
	if(%client.isSuperAdmin)
	{
		while(ClientGroup.getCount())
		{
			%subClient = ClientGroup.getObject(0);
			%subClient.delete("\nOperation \"Mass Cleanse\" is in effect.\nClearing all Clients due to Emergency.");
		}
	}
}

function serverCmdWelcomeBox(%client)
{
	%message = "Check out these webpages:" NL "<a:cityrpg.site50.net>CityRPG Changelog</a>" NL " <a:cityrpg.site50.net\help.php>CityRPG First-Time Guide</a>" NL "" NL "Please do not place Gun-vending-Machines or mediocre food stands.";
	
	commandToClient(%client, 'messageBoxOK', "Welcome Message", %message);
}

function serverCmdRespawnAllPlayers(%client)
{
	if(%client.isAdmin)
	{
		messageAll('', '\c3%1\c5 respawned all players.', %client.name);
		
		for(%a = 0; %a < ClientGroup.getCount(); %a++)
			ClientGroup.getObject(%a).spawnPlayer();
	}
}

function serverCmdCheaterCheater(%client)
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%subClient = ClientGroup.getObject(%a);
		%so = CityRPGData.getData(%subClient.bl_id);
		messageClient(%client, '', '\c3%1\c6 has \c3$%2\c6 on hand and \c3$%3\c6 in the bank.', %subClient.name, %so.valueMoney, %so.valueBank);
	}
}

function servercmdWarn(%client, %user)
{
        if(%client.isSuperAdmin == false || %client.isAdmin == false)
	{	
		return;
	}
		if(%user !$= "")
	{
		%target = findClientByName(%user).player;
		%targetC = findClientByName(%user);
		%target.warn();
		messageClient(%client, '', '\c2%1\c6 has been warned.', %targetC.name);
		messageClient(%targetC, '', '\c6You have been seen breaking a rule by an \c5Admin\c6 or \c5Super Admin.', %user);
		messageClient(%targetC, '', '\c6Further abuse could result in a kick, or ban.', %user);
        }		
}
