// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Server Preferences
// ============================================================
// Table of Contents
// 1. Basic Preferences
// 2. Price Preferences
// 2.1 Weapon Price Preferences
// 3. Tick Preferences
// 4. Demerit Preferences
// 5. Vehicle Preferences
// 7. Allowed Inmate 
// 8. Food
// 9. Banned Events
// 10. Hunger Colors and States
// ============================================================

// ============================================================
// Section 1 : Random Preferences
// ============================================================
$CityRPG::pref::demerits::pardonCost = 100;
$CityRPG::pref::demerits::recordShredCost = 5000;
$CityRPG::pref::demerits::demeritCost = 2;

$CityRPG::pref::demerits::demoteLevel = 250;
$CityRPG::pref::demerits::wantedLevel = 50;

$CityRPG::pref::demerits::reducePerTick = 30;
$CityRPG::pref::demerits::minBounty = 200;

$CityRPG::pref::resources::tree::regrowTime = 2.5;
$CityRPG::pref::resources::ore::noOreColorID = 50;
$CityRPG::pref::resources::ore::hasOreColorID = 49;

$CityRPG::pref::realestate::maxLots = 2;

$CityRPG::pref::giveDefaultTools = true;
$CityRPG::pref::defaultTools = "hammerItem wrenchItem printGun";

$CityRPG::pref::moneyDieTime = 60000;

$CityRPG::pref::players::startingCash = 50;

// ============================================================
// Section 2 : Price Preferences
// ============================================================
$CityRPG::prices::vehicleSpawn = 2500;
$CityRPG::prices::jailingBonus = 25;
$CityRPG::prices::reset = 500;
$CityRPG::prices::resourcePrice = 0.75;

// Section 2.1 - Weapon Prices
$CityRPG::prices::weapon::name[$CityRPG::guns] = "keyItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 5;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 0;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "gunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 80;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "taserItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 40;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "akimboGunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 150;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "shotgunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 260;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "rocketLauncherItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 350;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "sniperRifleItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 450;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "PillItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 30;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "crowbarItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 42;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "TommyGunItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 180;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::prices::weapon::name[$CityRPG::guns] = "CityRPGLBItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 100;
$CityRPG::prices::weapon::mineral[$CityRPG::guns++] = 1;

$CityRPG::guns = "";


// ============================================================
// Section 3 : Tick Preferences
// ============================================================
$CityRPG::tick::interest = 1.01;
$CityRPG::tick::creditInterest = 1.015;
$CityRPG::tick::interestTick = 12;
$CityRPG::tick::speed = 3;
$CityRPG::tick::promotionLevel = 24;

// ============================================================
// Section 4 : Demerit Preferences
// ============================================================
$CityRPG::demerits::hittingInnocents = 10;
$CityRPG::demerits::attemptedMurder = 25;
$CityRPG::demerits::murder = 75;
$CityRPG::demerits::breakingAndEntering = 10;
$CityRPG::demerits::attemptedBnE = 5;
$CityRPG::demerits::bountyPlacing = 250;
$CityRPG::demerits::bountyClaiming = 500;
$CityRPG::demerits::pickpocketing = 25;
$CityRPG::demerits::bankRobbery = 3000;
$CityRPG::demerits::tasingBros = 25;
$CityRPG::demerits::grandTheftAuto = 75;

// ============================================================
// Section 5 : Vehicle Preferences
// ============================================================
$CityRPG::vehicles::allowSpawn = true;

$CityRPG::vehicles::banned[0] = "FlyingWheeledJeepVehicle";
$CityRPG::vehicles::banned[1] = "MiniJetVehicle";
$CityRPG::vehicles::banned[2] = "StuntPlaneVehicle";
$CityRPG::vehicles::banned[4] = "MagicCarpetVehicle";
$CityRPG::vehicles::banned[5] = "TankVehicle";
$CityRPG::vehicles::banned[6] = "horseArmor";
$CityRPG::vehicles::banned[7] = "BlackhawkVehicle";

// ============================================================
// Section 7 : Allowed Inmate Items
// ============================================================
$CityRPG::demerits::jail::image["CityRPGLumberjackImage"] = true;
$CityRPG::demerits::jail::image["CityRPGShovelImage"] = true;
$CityRPG::demerits::jail::image["CityRPGPickaxeImage"] = true;

// Inmate Spawn Items
$CityRPG::demerits::jail::item[0] = "CityRPGPickaxeItem";

// ============================================================
// Section 8 : Food
// ============================================================
$CityRPG::portion[1] = "Small";
$CityRPG::portion[2] = "Medium";
$CityRPG::portion[3] = "Large";
$CityRPG::portion[4] = "Extra_Large";
$CityRPG::portion[5] = "Super_Sized";
$CityRPG::portion[6] = "Americanized";

// ============================================================
// Section 9 : Banned Events
// ============================================================
// $CityRPG::bannedEvent[nameSpace, name] = true; results in ban
// Note: This system is archaic.

// AIPlayer
$CityRPG::bannedEvent["AIPlayer", "setPlayerScale"] = true;

// fxDTSBrick
$CityRPG::bannedEvent["fxDTSBrick", "spawnExplosion"] = true;
$CityRPG::bannedEvent["fxDTSBrick", "spawnProjectile"] = true;

// gameConnection
$CityRPG::bannedEvent["gameConnection", "bottomPrint"] = true;
$CityRPG::bannedEvent["gameConnection", "incScore"] = true;
$CityRPG::bannedEvent["gameConnection", "instantRespawn"] = true;

// Player
$CityRPG::bannedEvent["Player", "addVelocity"] = true;
$CityRPG::bannedEvent["Player", "changeDatablock"] = true;
$CityRPG::bannedEvent["Player", "clearTools"] = true;
$CityRPG::bannedEvent["Player", "kill"] = true;
$CityRPG::bannedEvent["Player", "setHealth"] = true;
$CityRPG::bannedEvent["Player", "setPlayerScale"] = true;
$CityRPG::bannedEvent["Player", "spawnExplosion"] = true;
$CityRPG::bannedEvent["Player", "spawnProjectile"] = true;
$CityRPG::bannedEvent["Player", "setVelocity"] = true;

// ============================================================
// Section 10 : Hunger Colors and States
// ============================================================
$CityRPG::food::stateCount = 0;

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FF0000";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Starving";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FF6600";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Hungry";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFBB00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Content";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Satisfied";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "DDFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Full-up";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "AAFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Overfed";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "88FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Stuffed";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "66FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Bloated";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "44FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Engorged";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "22FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Fat";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "00FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Bursting";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFAA00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Disgusting";